<FLEXDOCXYZ_TEMPLATE VER='1.23'>
CREATED='2005-03-04 07:50:00'
LAST_UPDATE='2021-11-28 13:49:07'
DESIGNER_TOOL='FlexDoc.XYZ SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='flexdoc-xml-xsddoc2'
APP_NAME='FlexDoc/XML XSDDoc'
APP_VER='2.9.5'
APP_AUTHOR='Copyright © 2005-2021 Filigris Works, Leonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='FramesetTemplate'
DSM_TYPE_ID='xsddoc'
ROOT_ET='#DOCUMENTS'
DESCR='This template generates multi-file framed hypertext documentation for any number of XML Schemas.
<p>
<b>Note:</b> The destination output format may be only HTML.'
INIT_EXPR='callStockSection("Init");

setXMLNameForm (
  getBooleanParam("show.nsPrefix") ? "qualified" : "unqualified"
);'
TITLE_EXPR='getStringParam("docTitle")'
HTML_HEAD_EXPR='/* The following script is needed to support a possibility to pass
to the frameset file any HTML page contained in the documentation
to be loaded initially in the \'detailFrame\' frame on opening of
the frameset.

The page pathname should be specified relatively to the documentation
root directory (where index.html is located) and passed as the URL 
parameter (specified after \'?\' in the initial index.html URL),
for example:

  index.html?schemas/XMLSchema_xsd/complexTypes/namedAttributeGroup.html 
*/

\'<script type="text/javascript">
    targetPage = "" + window.location.search;
    if (targetPage != "" && targetPage != "undefined")
        targetPage = targetPage.substring(1);
    window.onload = function() {
        if (targetPage != "" && targetPage != "undefined")
            top.detailFrame.location = top.targetPage;
    }
</script>\''
<TEMPLATE_PARAMS>
	PARAM={
		param.name='$resourceOutputDir';
		param.title='Documentation resources directory';
		param.description='This parameter is used internally. It specifies the absolute pathname of a directory where all commonly used icons are to be stored.
<p>
If this pathname is empty, all resource (icon) files used by a given document will be stored in the local \'doc-files\' directory associated with that document.';
		param.type='string';
		param.defaultValue.expr='output.docFilesDir + "/resources"';
		param.hidden='true';
	}
	PARAM={
		param.name='docTitle';
		param.title='Documentation Title';
		param.description='${include help/params/docTitle.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.noEmptyString='true';
		param.defaultValue='XML Schema Documentation';
	}
	PARAM={
		param.name='gen.doc';
		param.title='Generate Details';
		param.title.style.bold='true';
		param.description='${include help/params/gen.doc.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='gen.doc.for.schemas';
		param.title='For Schemas';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.for.schemas.htm}';
		param.group='true';
	}
	PARAM={
		param.name='gen.doc.for.schemas.initial';
		param.title='Initial';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.for.schemas.initial.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.for.schemas.imported';
		param.title='Imported';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.for.schemas.imported.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.for.schemas.included';
		param.title='Included';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.for.schemas.included.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.for.schemas.redefined';
		param.title='Redefined';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.for.schemas.redefined.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.for.schemas.include';
		param.title='Include';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.for.schemas.include.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.doc.for.schemas.exclude';
		param.title='Exclude';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.for.schemas.exclude.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='gen.doc.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.sorting.htm}';
		param.group='true';
	}
	PARAM={
		param.name='gen.doc.sorting.namespaces';
		param.title='Namespaces';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.sorting.namespaces.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.sorting.schemas';
		param.title='Schemas';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.sorting.schemas.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.sorting.comps';
		param.title='Components';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.sorting.comps.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.overview';
		param.title='Overview Summary';
		param.description='${include help/params/gen.doc.overview.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.allcomps';
		param.title='All Component Summary';
		param.description='${include help/params/gen.doc.allcomps.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.namespace';
		param.title='Namespace Overviews';
		param.description='${include help/params/gen.doc.namespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.schema';
		param.title='Schema Overviews';
		param.description='${include help/params/gen.doc.schema.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.element';
		param.title='Elements';
		param.description='${include help/params/gen.doc.element.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.element.topLevel';
		param.title='Separate Top-Level Elements';
		param.description='${include help/params/gen.doc.element.topLevel.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.element.topLevel.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.element.topLevel.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.sorting.comps")';
	}
	PARAM={
		param.name='gen.doc.element.local';
		param.title='Local Elements';
		param.description='${include help/params/gen.doc.element.local.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type only;none';
	}
	PARAM={
		param.name='gen.doc.element.local.unifyByType';
		param.title='Unify By Type';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.element.local.unifyByType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.element.local.storeByParents';
		param.title='Store By Parents';
		param.title.style.italic='true';
		param.description='${include help/params/gen.doc.element.local.storeByParents.htm}';
		param.enablingExpr='! getBooleanParam("gen.doc.element.local.unifyByType")';
		param.type='boolean';
	}
	PARAM={
		param.name='gen.doc.complexType';
		param.title='Complex Types';
		param.description='${include help/params/gen.doc.complexType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.simpleType';
		param.title='Simple Types';
		param.description='${include help/params/gen.doc.simpleType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.group';
		param.title='Element Groups';
		param.description='${include help/params/gen.doc.group.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.attributeGroup';
		param.title='Attribute Groups';
		param.description='${include help/params/gen.doc.attributeGroup.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.attribute';
		param.title='Global Attributes';
		param.description='${include help/params/gen.doc.attribute.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='gen.doc.xmlnsBindings';
		param.title='XML Namespace Bindings';
		param.description='${include help/params/gen.doc.xmlnsBindings.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc';
		param.title='Details';
		param.title.style.bold='true';
		param.description='${include help/params/doc.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='doc.frgm';
		param.title='Fragments';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.frgm.schemas';
		param.title='Schema Summary';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.schemas.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.frgm.schemas.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.schemas.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.sorting.schemas")';
	}
	PARAM={
		param.name='doc.frgm.schemas.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.frgm.schemas.annotation.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
	}
	PARAM={
		param.name='doc.frgm.schemas.profile';
		param.title='Schema Profile';
		param.description='${include help/params/doc.frgm.schemas.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.schemas.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc.schema.profile.targetNamespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.schemas.profile.version';
		param.title='Version';
		param.description='${include help/params/doc.schema.profile.version.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.schemas.profile.components';
		param.title='Components';
		param.description='${include help/params/doc.schema.profile.components.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.schemas.profile.formDefault';
		param.title='Default NS-Qualified Form';
		param.description='${include help/params/doc.schema.profile.formDefault.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.schemas.profile.blockDefault';
		param.title='Default Block Attribute';
		param.description='${include help/params/doc.schema.profile.blockDefault.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.schemas.profile.blockDefault.value';
		param.title='Value';
		param.description='${include help/params/doc.schema.profile.blockDefault.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.schemas.profile.blockDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.schema.profile.blockDefault.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.schemas.profile.finalDefault';
		param.title='Default Final Attribute';
		param.description='${include help/params/doc.schema.profile.finalDefault.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.schemas.profile.finalDefault.value';
		param.title='Value';
		param.description='${include help/params/doc.schema.profile.finalDefault.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.schemas.profile.finalDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.schema.profile.finalDefault.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.schemas.profile.relatedSchemas';
		param.title='Related Schemas';
		param.description='${include help/params/doc.schema.profile.relatedSchemas.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps';
		param.title='Component Summary';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.frgm.comps.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.frgm.comps.for.elements';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.elements.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.element")';
	}
	PARAM={
		param.name='doc.frgm.comps.for.elements.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.elements.local.htm}';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type;none';
		param.defaultValue.expr='getStringParam("gen.doc.element.local")';
	}
	PARAM={
		param.name='doc.frgm.comps.for.complexTypes';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.complexTypes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.complexType")';
	}
	PARAM={
		param.name='doc.frgm.comps.for.simpleTypes';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.simpleTypes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.simpleType")';
	}
	PARAM={
		param.name='doc.frgm.comps.for.groups';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.groups.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.group")';
	}
	PARAM={
		param.name='doc.frgm.comps.for.attributeGroups';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.attributeGroups.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.attributeGroup")';
	}
	PARAM={
		param.name='doc.frgm.comps.for.attributes';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.attributes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.attribute")';
	}
	PARAM={
		param.name='doc.frgm.comps.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.sorting.comps")';
	}
	PARAM={
		param.name='doc.frgm.comps.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.frgm.comps.annotation.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
	}
	PARAM={
		param.name='doc.frgm.comps.profile';
		param.title='Component Profile';
		param.description='${include help/params/doc.frgm.comps.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc.comp.profile.namespace.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.type';
		param.title='Type';
		param.description='${include help/params/doc.comp.profile.type.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.content';
		param.title='Content';
		param.description='${include help/params/doc.comp.profile.content.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.abstract';
		param.title='Abstract';
		param.description='${include help/params/doc.comp.profile.abstract.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.block';
		param.title='Block';
		param.description='${include help/params/doc.comp.profile.block.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.block.value';
		param.title='Value';
		param.description='${include help/params/doc.comp.profile.block.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.block.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.comp.profile.block.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.final';
		param.title='Final';
		param.description='${include help/params/doc.comp.profile.final.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.final.value';
		param.title='Value';
		param.description='${include help/params/doc.comp.profile.final.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.final.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.comp.profile.final.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.subst';
		param.title='Subst.Gr';
		param.description='${include help/params/doc.comp.profile.subst.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.subst.heads';
		param.title='List of group heads';
		param.description='${include help/params/doc.comp.profile.subst.heads.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.subst.members';
		param.title='List of group members';
		param.description='${include help/params/doc.comp.profile.subst.members.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.nillable';
		param.title='Nillable';
		param.description='${include help/params/doc.comp.profile.nillable.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.defined';
		param.title='Defined';
		param.description='${include help/params/doc.comp.profile.defined.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc.comp.profile.includes.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.redefines';
		param.title='Redefines';
		param.description='${include help/params/doc.comp.profile.redefines.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.redefined';
		param.title='Redefined';
		param.description='${include help/params/doc.comp.profile.redefined.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.profile.used';
		param.title='Used';
		param.description='${include help/params/doc.comp.profile.used.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.lists';
		param.title='Related Component Lists';
		param.description='${include help/params/doc.frgm.comps.lists.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.frgm.comps.lists.contentAttributes';
		param.title='Content Attributes';
		param.description='${include help/params/doc.frgm.comps.lists.contentAttributes.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.lists.contentAttributes.value';
		param.title='Show Type/Value Info';
		param.description='${include help/params/doc.frgm.comps.lists.contentAttributes.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.lists.contentAttributes.wildcards';
		param.title='Include Wildcards';
		param.description='${include help/params/doc.frgm.comps.lists.contentAttributes.wildcards.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.lists.contentElements';
		param.title='Content Elements';
		param.description='${include help/params/doc.frgm.comps.lists.contentElements.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.frgm.comps.lists.contentElements.layout';
		param.title='List Layout';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.lists.layout.htm}';
		param.type='enum';
		param.enum.values='flow;one_column;two_columns;optimal';
		param.enum.displayValues='flow;one column;two columns;optimal';
		param.defaultValue='optimal';
	}
	PARAM={
		param.name='doc.frgm.comps.lists.contentElements.wildcards';
		param.title='Include Wildcards';
		param.description='${include help/params/doc.frgm.comps.lists.contentElements.wildcards.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.overview';
		param.title='Overview Summary';
		param.title.style.bold='true';
		param.description='${include help/params/doc.overview.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.overview.title';
		param.title='Title';
		param.description='${include help/params/doc.overview.title.htm}';
		param.type='string';
		param.defaultValue.expr='getStringParam("docTitle")';
	}
	PARAM={
		param.name='doc.overview.namespaces';
		param.title='Namespace Summary';
		param.description='${include help/params/doc.overview.namespaces.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.overview.namespaces.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc.overview.namespaces.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.sorting.namespaces")';
	}
	PARAM={
		param.name='doc.overview.schemas';
		param.title='Schema Summary';
		param.description='${include help/params/doc.overview.schemas.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.overview.schemas.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.schemas.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.sorting")';
	}
	PARAM={
		param.name='doc.overview.schemas.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.frgm.schemas.annotation$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.schemas.annotation")';
	}
	PARAM={
		param.name='doc.overview.schemas.profile';
		param.title='Schema Profile';
		param.description='${include help/params/doc.frgm.schemas.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile")';
	}
	PARAM={
		param.name='doc.overview.schemas.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc.frgm.schemas.profile.targetNamespace$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.targetNamespace")';
	}
	PARAM={
		param.name='doc.overview.schemas.profile.version';
		param.title='Version';
		param.description='${include help/params/doc.frgm.schemas.profile.version$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.version")';
	}
	PARAM={
		param.name='doc.overview.schemas.profile.components';
		param.title='Components';
		param.description='${include help/params/doc.frgm.schemas.profile.components$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.components")';
	}
	PARAM={
		param.name='doc.overview.schemas.profile.formDefault';
		param.title='Default NS-Qualified Form';
		param.description='${include help/params/doc.frgm.schemas.profile.formDefault$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.formDefault")';
	}
	PARAM={
		param.name='doc.overview.schemas.profile.blockDefault';
		param.title='Default Block Attribute';
		param.description='${include help/params/doc.frgm.schemas.profile.blockDefault$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.blockDefault")';
	}
	PARAM={
		param.name='doc.overview.schemas.profile.blockDefault.value';
		param.title='Value';
		param.description='${include help/params/doc.frgm.schemas.profile.blockDefault.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.blockDefault.value")';
	}
	PARAM={
		param.name='doc.overview.schemas.profile.blockDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.frgm.schemas.profile.blockDefault.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.blockDefault.meaning")';
	}
	PARAM={
		param.name='doc.overview.schemas.profile.finalDefault';
		param.title='Default Final Attribute';
		param.description='${include help/params/doc.frgm.schemas.profile.finalDefault$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.finalDefault")';
	}
	PARAM={
		param.name='doc.overview.schemas.profile.finalDefault.value';
		param.title='Value';
		param.description='${include help/params/doc.frgm.schemas.profile.finalDefault.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.finalDefault.value")';
	}
	PARAM={
		param.name='doc.overview.schemas.profile.finalDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.frgm.schemas.profile.finalDefault.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.finalDefault.meaning")';
	}
	PARAM={
		param.name='doc.overview.schemas.profile.relatedSchemas';
		param.title='Related Schemas';
		param.description='${include help/params/doc.frgm.schemas.profile.relatedSchemas$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.relatedSchemas")';
	}
	PARAM={
		param.name='doc.allcomps';
		param.title='All Component Summary';
		param.title.style.bold='true';
		param.description='${include help/params/doc.allcomps.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.allcomps.comps.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for$.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.allcomps.comps.for.elements';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.elements$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.elements")';
	}
	PARAM={
		param.name='doc.allcomps.comps.for.elements.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.elements.local$.htm}';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type;none';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.for.elements.local")';
	}
	PARAM={
		param.name='doc.allcomps.comps.for.complexTypes';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.complexTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.complexTypes")';
	}
	PARAM={
		param.name='doc.allcomps.comps.for.simpleTypes';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.simpleTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.simpleTypes")';
	}
	PARAM={
		param.name='doc.allcomps.comps.for.groups';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.groups$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.groups")';
	}
	PARAM={
		param.name='doc.allcomps.comps.for.attributeGroups';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.attributeGroups$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.attributeGroups")';
	}
	PARAM={
		param.name='doc.allcomps.comps.for.attributes';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.attributes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.attributes")';
	}
	PARAM={
		param.name='doc.allcomps.comps.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.sorting")';
	}
	PARAM={
		param.name='doc.allcomps.comps.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.frgm.comps.annotation$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.annotation")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile';
		param.title='Component Profile';
		param.description='${include help/params/doc.frgm.comps.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc.comp.profile.namespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.type';
		param.title='Type';
		param.description='${include help/params/doc.frgm.comps.profile.type$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.type")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.content';
		param.title='Content';
		param.description='${include help/params/doc.frgm.comps.profile.content$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.content")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.abstract';
		param.title='Abstract';
		param.description='${include help/params/doc.frgm.comps.profile.abstract$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.abstract")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.block';
		param.title='Block';
		param.description='${include help/params/doc.frgm.comps.profile.block$.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.profile.block")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.block.value';
		param.title='Value';
		param.description='${include help/params/doc.frgm.comps.profile.block.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.block.value")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.block.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.frgm.comps.profile.block.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.block.meaning")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.final';
		param.title='Final';
		param.description='${include help/params/doc.frgm.comps.profile.final$.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.profile.final")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.final.value';
		param.title='Value';
		param.description='${include help/params/doc.frgm.comps.profile.final.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.final.value")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.final.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.frgm.comps.profile.final.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.final.meaning")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.subst';
		param.title='Subst.Gr';
		param.description='${include help/params/doc.frgm.comps.profile.subst$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.subst")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.subst.heads';
		param.title='List of group heads';
		param.description='${include help/params/doc.frgm.comps.profile.subst.heads$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.subst.heads")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.subst.members';
		param.title='List of group members';
		param.description='${include help/params/doc.frgm.comps.profile.subst.members$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.subst.members")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.nillable';
		param.title='Nillable';
		param.description='${include help/params/doc.frgm.comps.profile.nillable$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.nillable")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.defined';
		param.title='Defined';
		param.description='${include help/params/doc.frgm.comps.profile.defined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.defined")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc.frgm.comps.profile.includes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.includes")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.redefines';
		param.title='Redefines';
		param.description='${include help/params/doc.frgm.comps.profile.redefines$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.redefines")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.redefined';
		param.title='Redefined';
		param.description='${include help/params/doc.frgm.comps.profile.redefined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.redefined")';
	}
	PARAM={
		param.name='doc.allcomps.comps.profile.used';
		param.title='Used';
		param.description='${include help/params/doc.frgm.comps.profile.used$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.used")';
	}
	PARAM={
		param.name='doc.allcomps.comps.lists';
		param.title='Related Component Lists';
		param.description='${include help/params/doc.frgm.comps.lists$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists")';
	}
	PARAM={
		param.name='doc.allcomps.comps.lists.contentAttributes';
		param.title='Content Attributes';
		param.description='${include help/params/doc.frgm.comps.lists.contentAttributes$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentAttributes")';
	}
	PARAM={
		param.name='doc.allcomps.comps.lists.contentAttributes.value';
		param.title='Show Type/Value Info';
		param.description='${include help/params/doc.frgm.comps.lists.contentAttributes.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentAttributes.value")';
	}
	PARAM={
		param.name='doc.allcomps.comps.lists.contentAttributes.wildcards';
		param.title='Include Wildcards';
		param.description='${include help/params/doc.frgm.comps.lists.contentAttributes.wildcards$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentAttributes.wildcards")';
	}
	PARAM={
		param.name='doc.allcomps.comps.lists.contentElements';
		param.title='Content Elements';
		param.description='${include help/params/doc.frgm.comps.lists.contentElements$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentElements")';
	}
	PARAM={
		param.name='doc.allcomps.comps.lists.contentElements.layout';
		param.title='List Layout';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.lists.contentElements.layout$.htm}';
		param.type='enum';
		param.enum.values='flow;one_column;two_columns;optimal';
		param.enum.displayValues='flow;one column;two columns;optimal';
		param.defaultValue='optimal';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.lists.contentElements.layout")';
	}
	PARAM={
		param.name='doc.allcomps.comps.lists.contentElements.wildcards';
		param.title='Include Wildcards';
		param.description='${include help/params/doc.frgm.comps.lists.contentElements.wildcards$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentElements.wildcards")';
	}
	PARAM={
		param.name='doc.namespace';
		param.title='Namespace Overview';
		param.title.style.bold='true';
		param.description='${include help/params/doc.namespace.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.namespace.profile';
		param.title='Namespace Profile';
		param.description='${include help/params/doc.namespace.profile.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.namespace.schemas';
		param.title='Schema Summary';
		param.description='${include help/params/doc.namespace.schemas.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.namespace.schemas.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.schemas.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.sorting")';
	}
	PARAM={
		param.name='doc.namespace.schemas.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.frgm.schemas.annotation$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.schemas.annotation")';
	}
	PARAM={
		param.name='doc.namespace.schemas.profile';
		param.title='Schema Profile';
		param.description='${include help/params/doc.frgm.schemas.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile")';
	}
	PARAM={
		param.name='doc.namespace.schemas.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc.frgm.schemas.profile.targetNamespace$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.targetNamespace")';
	}
	PARAM={
		param.name='doc.namespace.schemas.profile.version';
		param.title='Version';
		param.description='${include help/params/doc.frgm.schemas.profile.version$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.version")';
	}
	PARAM={
		param.name='doc.namespace.schemas.profile.components';
		param.title='Components';
		param.description='${include help/params/doc.frgm.schemas.profile.components$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.components")';
	}
	PARAM={
		param.name='doc.namespace.schemas.profile.formDefault';
		param.title='Default NS-Qualified Form';
		param.description='${include help/params/doc.frgm.schemas.profile.formDefault$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.formDefault")';
	}
	PARAM={
		param.name='doc.namespace.schemas.profile.blockDefault';
		param.title='Default Block Attribute';
		param.description='${include help/params/doc.frgm.schemas.profile.blockDefault$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.blockDefault")';
	}
	PARAM={
		param.name='doc.namespace.schemas.profile.blockDefault.value';
		param.title='Value';
		param.description='${include help/params/doc.frgm.schemas.profile.blockDefault.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.blockDefault.value")';
	}
	PARAM={
		param.name='doc.namespace.schemas.profile.blockDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.frgm.schemas.profile.blockDefault.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.blockDefault.meaning")';
	}
	PARAM={
		param.name='doc.namespace.schemas.profile.finalDefault';
		param.title='Default Final Attribute';
		param.description='${include help/params/doc.frgm.schemas.profile.finalDefault$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.finalDefault")';
	}
	PARAM={
		param.name='doc.namespace.schemas.profile.finalDefault.value';
		param.title='Value';
		param.description='${include help/params/doc.frgm.schemas.profile.finalDefault.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.finalDefault.value")';
	}
	PARAM={
		param.name='doc.namespace.schemas.profile.finalDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.frgm.schemas.profile.finalDefault.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.finalDefault.meaning")';
	}
	PARAM={
		param.name='doc.namespace.schemas.profile.relatedSchemas';
		param.title='Related Schemas';
		param.description='${include help/params/doc.frgm.schemas.profile.relatedSchemas$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.schemas.profile.relatedSchemas")';
	}
	PARAM={
		param.name='doc.namespace.comps';
		param.title='Component Summary';
		param.title.style.bold='true';
		param.description='${include help/params/doc.namespace.comps.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.namespace.comps.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for$.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.namespace.comps.for.elements';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.elements$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.elements")';
	}
	PARAM={
		param.name='doc.namespace.comps.for.elements.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.elements.local$.htm}';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type;none';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.for.elements.local")';
	}
	PARAM={
		param.name='doc.namespace.comps.for.complexTypes';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.complexTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.complexTypes")';
	}
	PARAM={
		param.name='doc.namespace.comps.for.simpleTypes';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.simpleTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.simpleTypes")';
	}
	PARAM={
		param.name='doc.namespace.comps.for.groups';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.groups$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.groups")';
	}
	PARAM={
		param.name='doc.namespace.comps.for.attributeGroups';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.attributeGroups$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.attributeGroups")';
	}
	PARAM={
		param.name='doc.namespace.comps.for.attributes';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.attributes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.attributes")';
	}
	PARAM={
		param.name='doc.namespace.comps.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.sorting")';
	}
	PARAM={
		param.name='doc.namespace.comps.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.frgm.comps.annotation$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.annotation")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile';
		param.title='Component Profile';
		param.description='${include help/params/doc.frgm.comps.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc.frgm.comps.profile.namespace$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.namespace")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.type';
		param.title='Type';
		param.description='${include help/params/doc.frgm.comps.profile.type$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.type")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.content';
		param.title='Content';
		param.description='${include help/params/doc.frgm.comps.profile.content$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.content")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.abstract';
		param.title='Abstract';
		param.description='${include help/params/doc.frgm.comps.profile.abstract$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.abstract")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.block';
		param.title='Block';
		param.description='${include help/params/doc.frgm.comps.profile.block$.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.profile.block")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.block.value';
		param.title='Value';
		param.description='${include help/params/doc.frgm.comps.profile.block.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.block.value")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.block.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.frgm.comps.profile.block.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.block.meaning")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.final';
		param.title='Final';
		param.description='${include help/params/doc.frgm.comps.profile.final$.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.profile.final")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.final.value';
		param.title='Value';
		param.description='${include help/params/doc.frgm.comps.profile.final.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.final.value")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.final.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.frgm.comps.profile.final.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.final.meaning")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.subst';
		param.title='Subst.Gr';
		param.description='${include help/params/doc.frgm.comps.profile.subst$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.subst")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.subst.heads';
		param.title='List of group heads';
		param.description='${include help/params/doc.frgm.comps.profile.subst.heads$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.subst.heads")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.subst.members';
		param.title='List of group members';
		param.description='${include help/params/doc.frgm.comps.profile.subst.members$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.subst.members")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.nillable';
		param.title='Nillable';
		param.description='${include help/params/doc.frgm.comps.profile.nillable$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.nillable")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.defined';
		param.title='Defined';
		param.description='${include help/params/doc.frgm.comps.profile.defined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.defined")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc.frgm.comps.profile.includes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.includes")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.redefines';
		param.title='Redefines';
		param.description='${include help/params/doc.frgm.comps.profile.redefines$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.redefines")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.redefined';
		param.title='Redefined';
		param.description='${include help/params/doc.frgm.comps.profile.redefined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.redefined")';
	}
	PARAM={
		param.name='doc.namespace.comps.profile.used';
		param.title='Used';
		param.description='${include help/params/doc.frgm.comps.profile.used$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.used")';
	}
	PARAM={
		param.name='doc.namespace.comps.lists';
		param.title='Related Component Lists';
		param.description='${include help/params/doc.frgm.comps.lists$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists")';
	}
	PARAM={
		param.name='doc.namespace.comps.lists.contentAttributes';
		param.title='Content Attributes';
		param.description='${include help/params/doc.frgm.comps.lists.contentAttributes$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentAttributes")';
	}
	PARAM={
		param.name='doc.namespace.comps.lists.contentAttributes.value';
		param.title='Show Type/Value Info';
		param.description='${include help/params/doc.frgm.comps.lists.contentAttributes.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentAttributes.value")';
	}
	PARAM={
		param.name='doc.namespace.comps.lists.contentAttributes.wildcards';
		param.title='Include Wildcards';
		param.description='${include help/params/doc.frgm.comps.lists.contentAttributes.wildcards$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentAttributes.wildcards")';
	}
	PARAM={
		param.name='doc.namespace.comps.lists.contentElements';
		param.title='Content Elements';
		param.description='${include help/params/doc.frgm.comps.lists.contentElements$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentElements")';
	}
	PARAM={
		param.name='doc.namespace.comps.lists.contentElements.layout';
		param.title='List Layout';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.lists.contentElements.layout$.htm}';
		param.type='enum';
		param.enum.values='flow;one_column;two_columns;optimal';
		param.enum.displayValues='flow;one column;two columns;optimal';
		param.defaultValue='optimal';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.lists.contentElements.layout")';
	}
	PARAM={
		param.name='doc.namespace.comps.lists.contentElements.wildcards';
		param.title='Include Wildcards';
		param.description='${include help/params/doc.frgm.comps.lists.contentElements.wildcards$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentElements.wildcards")';
	}
	PARAM={
		param.name='doc.schema';
		param.title='Schema Overview';
		param.title.style.bold='true';
		param.description='${include help/params/doc.schema.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.schema.profile';
		param.title='Schema Profile';
		param.description='${include help/params/doc.schema.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.profile.targetNamespace';
		param.title='Target Namespace';
		param.description='${include help/params/doc.schema.profile.targetNamespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.profile.version';
		param.title='Version';
		param.description='${include help/params/doc.schema.profile.version.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.profile.components';
		param.title='Components';
		param.description='${include help/params/doc.schema.profile.components.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.profile.formDefault';
		param.title='Default NS-Qualified Form';
		param.description='${include help/params/doc.schema.profile.formDefault.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.profile.blockDefault';
		param.title='Default Block Attribute';
		param.description='${include help/params/doc.schema.profile.blockDefault.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.profile.blockDefault.value';
		param.title='Value';
		param.description='${include help/params/doc.schema.profile.blockDefault.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.profile.blockDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.schema.profile.blockDefault.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.profile.finalDefault';
		param.title='Default Final Attribute';
		param.description='${include help/params/doc.schema.profile.finalDefault.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.profile.finalDefault.value';
		param.title='Value';
		param.description='${include help/params/doc.schema.profile.finalDefault.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.profile.finalDefault.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.schema.profile.finalDefault.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.profile.relatedSchemas';
		param.title='Related Schemas';
		param.description='${include help/params/doc.schema.profile.relatedSchemas.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.schema.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.comps';
		param.title='Component Summary';
		param.title.style.bold='true';
		param.description='${include help/params/doc.schema.comps.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.comps.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for$.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.schema.comps.for.elements';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.elements$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.elements")';
	}
	PARAM={
		param.name='doc.schema.comps.for.elements.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.elements.local$.htm}';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type;none';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.for.elements.local")';
	}
	PARAM={
		param.name='doc.schema.comps.for.complexTypes';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.complexTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.complexTypes")';
	}
	PARAM={
		param.name='doc.schema.comps.for.simpleTypes';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.simpleTypes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.simpleTypes")';
	}
	PARAM={
		param.name='doc.schema.comps.for.groups';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.groups$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.groups")';
	}
	PARAM={
		param.name='doc.schema.comps.for.attributeGroups';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.attributeGroups$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.attributeGroups")';
	}
	PARAM={
		param.name='doc.schema.comps.for.attributes';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.for.attributes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.for.attributes")';
	}
	PARAM={
		param.name='doc.schema.comps.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.sorting$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.sorting")';
	}
	PARAM={
		param.name='doc.schema.comps.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.frgm.comps.annotation$.htm}';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.annotation")';
	}
	PARAM={
		param.name='doc.schema.comps.profile';
		param.title='Component Profile';
		param.description='${include help/params/doc.frgm.comps.profile$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc.frgm.comps.profile.namespace$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.namespace")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.type';
		param.title='Type';
		param.description='${include help/params/doc.frgm.comps.profile.type$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.type")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.content';
		param.title='Content';
		param.description='${include help/params/doc.frgm.comps.profile.content$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.content")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.abstract';
		param.title='Abstract';
		param.description='${include help/params/doc.frgm.comps.profile.abstract$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.abstract")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.block';
		param.title='Block';
		param.description='${include help/params/doc.frgm.comps.profile.block$.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.profile.block")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.block.value';
		param.title='Value';
		param.description='${include help/params/doc.frgm.comps.profile.block.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.block.value")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.block.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.frgm.comps.profile.block.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.block.meaning")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.final';
		param.title='Final';
		param.description='${include help/params/doc.frgm.comps.profile.final$.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.profile.final")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.final.value';
		param.title='Value';
		param.description='${include help/params/doc.frgm.comps.profile.final.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.final.value")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.final.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.frgm.comps.profile.final.meaning$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.final.meaning")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.subst';
		param.title='Subst.Gr';
		param.description='${include help/params/doc.frgm.comps.profile.subst$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.subst")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.subst.heads';
		param.title='List of group heads';
		param.description='${include help/params/doc.frgm.comps.profile.subst.heads$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.subst.heads")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.subst.members';
		param.title='List of group members';
		param.description='${include help/params/doc.frgm.comps.profile.subst.members$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.subst.members")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.nillable';
		param.title='Nillable';
		param.description='${include help/params/doc.frgm.comps.profile.nillable$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.nillable")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.defined';
		param.title='Defined';
		param.description='${include help/params/doc.frgm.comps.profile.defined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.defined")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc.frgm.comps.profile.includes$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.includes")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.redefines';
		param.title='Redefines';
		param.description='${include help/params/doc.frgm.comps.profile.redefines$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.redefines")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.redefined';
		param.title='Redefined';
		param.description='${include help/params/doc.frgm.comps.profile.redefined$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.redefined")';
	}
	PARAM={
		param.name='doc.schema.comps.profile.used';
		param.title='Used';
		param.description='${include help/params/doc.frgm.comps.profile.used$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.profile.used")';
	}
	PARAM={
		param.name='doc.schema.comps.lists';
		param.title='Related Component Lists';
		param.description='${include help/params/doc.frgm.comps.lists$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists")';
	}
	PARAM={
		param.name='doc.schema.comps.lists.contentAttributes';
		param.title='Content Attributes';
		param.description='${include help/params/doc.frgm.comps.lists.contentAttributes$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentAttributes")';
	}
	PARAM={
		param.name='doc.schema.comps.lists.contentAttributes.value';
		param.title='Show Type/Value Info';
		param.description='${include help/params/doc.frgm.comps.lists.contentAttributes.value$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentAttributes.value")';
	}
	PARAM={
		param.name='doc.schema.comps.lists.contentAttributes.wildcards';
		param.title='Include Wildcards';
		param.description='${include help/params/doc.frgm.comps.lists.contentAttributes.wildcards$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentAttributes.wildcards")';
	}
	PARAM={
		param.name='doc.schema.comps.lists.contentElements';
		param.title='Content Elements';
		param.description='${include help/params/doc.frgm.comps.lists.contentElements$.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentElements")';
	}
	PARAM={
		param.name='doc.schema.comps.lists.contentElements.layout';
		param.title='List Layout';
		param.title.style.italic='true';
		param.description='${include help/params/doc.frgm.comps.lists.contentElements.layout$.htm}';
		param.type='enum';
		param.enum.values='flow;one_column;two_columns;optimal';
		param.enum.displayValues='flow;one column;two columns;optimal';
		param.defaultValue='optimal';
		param.defaultValue.expr='getStringParam("doc.frgm.comps.lists.contentElements.layout")';
	}
	PARAM={
		param.name='doc.schema.comps.lists.contentElements.wildcards';
		param.title='Include Wildcards';
		param.description='${include help/params/doc.frgm.comps.lists.contentElements.wildcards$.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.frgm.comps.lists.contentElements.wildcards")';
	}
	PARAM={
		param.name='doc.schema.xml';
		param.title='XML Source';
		param.title.style.bold='true';
		param.description='${include help/params/doc.schema.xml.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.schema.xml.separate';
		param.title='Separate File';
		param.description='${include help/params/doc.schema.xml.separate.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.schema.xml.box';
		param.title='Enclose in Box';
		param.description='${include help/params/doc.schema.xml.box.htm}';
		param.type='boolean';
		param.defaultValue.expr='! getBooleanParam("doc.schema.xml.separate")';
	}
	PARAM={
		param.name='doc.schema.xml.remove.anns';
		param.title='Remove Annotations';
		param.description='${include help/params/doc.schema.xml.remove.anns.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.comp';
		param.title='Component Documentation';
		param.title.style.bold='true';
		param.description='${include help/params/doc.comp.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.comp.profile';
		param.title='Component Profile';
		param.description='${include help/params/doc.comp.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.namespace';
		param.title='Namespace';
		param.description='${include help/params/doc.comp.profile.namespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.type';
		param.title='Type';
		param.description='${include help/params/doc.comp.profile.type.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.content';
		param.title='Content';
		param.description='${include help/params/doc.comp.profile.content.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.abstract';
		param.title='Abstract';
		param.description='${include help/params/doc.comp.profile.abstract.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.block';
		param.title='Block';
		param.description='${include help/params/doc.comp.profile.block.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
	}
	PARAM={
		param.name='doc.comp.profile.block.value';
		param.title='Value';
		param.description='${include help/params/doc.comp.profile.block.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.block.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.comp.profile.block.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.final';
		param.title='Final';
		param.description='${include help/params/doc.comp.profile.final.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
	}
	PARAM={
		param.name='doc.comp.profile.final.value';
		param.title='Value';
		param.description='${include help/params/doc.comp.profile.final.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.final.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.comp.profile.final.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.subst';
		param.title='Subst.Gr';
		param.description='${include help/params/doc.comp.profile.subst.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.subst.heads';
		param.title='List of group heads';
		param.description='${include help/params/doc.comp.profile.subst.heads.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.subst.members';
		param.title='List of group members';
		param.description='${include help/params/doc.comp.profile.subst.members.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.comp.profile.nillable';
		param.title='Nillable';
		param.description='${include help/params/doc.comp.profile.nillable.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.defined';
		param.title='Defined';
		param.description='${include help/params/doc.comp.profile.defined.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.includes';
		param.title='Includes';
		param.description='${include help/params/doc.comp.profile.includes.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.redefines';
		param.title='Redefines';
		param.description='${include help/params/doc.comp.profile.redefines.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.redefined';
		param.title='Redefined';
		param.description='${include help/params/doc.comp.profile.redefined.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.profile.used';
		param.title='Used';
		param.description='${include help/params/doc.comp.profile.used.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.diagram';
		param.title='Diagram';
		param.description='${include help/params/doc.comp.diagram.htm}';
		param.enablingExpr='getBooleanParam("DiagramKit")
&&
dsmType.imageProvider != null';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='getBooleanParam("DiagramKit")
&&
dsmType.imageProvider != null';
	}
	PARAM={
		param.name='doc.comp.diagram.links';
		param.title='Hyperlinks';
		param.description='${include help/params/doc.comp.diagram.links.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='doc.comp.diagram.links.attribute.global';
		param.title='Global Attributes';
		param.description='${include help/params/doc.comp.diagram.links.attribute.global.htm}';
		param.type='enum';
		param.enum.values='global;local';
		param.enum.displayValues='global documentation;local documentation';
	}
	PARAM={
		param.name='doc.comp.diagram.links.element.local';
		param.title='Local Elements';
		param.description='${include help/params/doc.comp.diagram.links.element.local.htm}';
		param.type='enum';
		param.enum.values='global;local';
		param.enum.displayValues='global documentation;local documentation';
	}
	PARAM={
		param.name='doc.comp.diagram.links.compositors';
		param.title='Compositors';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.xmlRep';
		param.title='XML Representation Summary';
		param.description='${include help/params/doc.comp.xmlRep.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.xmlRep.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.xmlRep.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.comp.xmlRep.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.xmlRep.for.element.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.xmlRep.for.complexType';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.xmlRep.for.complexType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.xmlRep.for.simpleType';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.xmlRep.for.simpleType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.xmlRep.for.group';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.xmlRep.for.group.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.xmlRep.for.attribute';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.xmlRep.for.attribute.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.xmlRep.for.attributeGroup';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.xmlRep.for.attributeGroup.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.xmlRep.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.xmlRep.sorting.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.comp.simpleContent';
		param.title='Simple Content Detail';
		param.description='${include help/params/doc.comp.simpleContent.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.simpleContent.restrictions';
		param.title='Restrictions';
		param.description='${include help/params/doc.comp.simpleContent.restrictions.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.simpleContent.restrictions.annotation';
		param.title='Annotations';
		param.description='${include help/params/doc.comp.simpleContent.restrictions.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.simpleContent.default';
		param.title='Default Value';
		param.description='${include help/params/doc.comp.simpleContent.default.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.simpleContent.fixed';
		param.title='Fixed Value';
		param.description='${include help/params/doc.comp.simpleContent.fixed.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.lists';
		param.title='Lists of Related Components';
		param.title.style.bold='true';
		param.description='${include help/params/doc.comp.lists.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.lists.layout';
		param.title='List Layout';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.lists.layout.htm}';
		param.type='enum';
		param.enum.values='flow;one_column;two_columns;optimal';
		param.enum.displayValues='flow;one column;two columns;optimal';
		param.defaultValue='optimal';
	}
	PARAM={
		param.name='doc.comp.lists.contentElements';
		param.title='Content Elements';
		param.description='${include help/params/doc.comp.lists.contentElements.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.lists.containingElements';
		param.title='Containing Elements';
		param.description='${include help/params/doc.comp.lists.containingElements.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.lists.substitutableElements';
		param.title='Substitutable Elements';
		param.description='${include help/params/doc.comp.lists.substitutableElements.htm}';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("doc.comp.profile.subst.heads")';
	}
	PARAM={
		param.name='doc.comp.lists.substitutingElements';
		param.title='Substituting Elements';
		param.description='${include help/params/doc.comp.lists.substitutingElements.htm}';
		param.type='boolean';
		param.defaultValue.expr='! getBooleanParam("doc.comp.profile.subst.members")';
	}
	PARAM={
		param.name='doc.comp.lists.childrenBySubst';
		param.title='Children By Substitutions';
		param.description='${include help/params/doc.comp.lists.childrenBySubst.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.lists.parentsBySubst';
		param.title='Parents By Substitutions';
		param.description='${include help/params/doc.comp.lists.parentsBySubst.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.lists.directSubtypes';
		param.title='Direct Subtypes';
		param.description='${include help/params/doc.comp.lists.directSubtypes.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.lists.indirectSubtypes';
		param.title='Indirect Subtypes';
		param.description='${include help/params/doc.comp.lists.indirectSubtypes.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.lists.basedElements';
		param.title='All Based Elements';
		param.description='${include help/params/doc.comp.lists.basedElements.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.lists.basedAttributes';
		param.title='All Based Attributes';
		param.description='${include help/params/doc.comp.lists.basedAttributes.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.usage';
		param.title='Usage / Definition Locations';
		param.description='${include help/params/doc.comp.usage.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.usage.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.usage.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.comp.usage.for.element.global';
		param.title='Global Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.usage.for.element.global.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.usage.for.element.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.usage.for.element.local.htm}';
		param.type='enum';
		param.enum.values='always;multiple;never';
		param.enum.displayValues='always;multiple only;never';
		param.defaultValue='multiple';
	}
	PARAM={
		param.name='doc.comp.usage.for.complexType';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.usage.for.complexType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.usage.for.simpleType';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.usage.for.simpleType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.usage.for.group';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.usage.for.group.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.usage.for.attribute';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.usage.for.attribute.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.usage.for.attributeGroup';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.usage.for.attributeGroup.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.usage.layout';
		param.title='List Layout';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.usage.layout.htm}';
		param.type='enum';
		param.enum.values='flow;one_column;two_columns;optimal';
		param.enum.displayValues='flow;one column;two columns;optimal';
		param.defaultValue='optimal';
	}
	PARAM={
		param.name='doc.comp.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.comp.annotation.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.annotation.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.annotation.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.comp.annotation.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.annotation.for.element.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.annotation.for.complexType';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.annotation.for.complexType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.annotation.for.simpleType';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.annotation.for.simpleType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.annotation.for.group';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.annotation.for.group.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.annotation.for.attribute';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.annotation.for.attribute.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.annotation.for.attributeGroup';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.annotation.for.attributeGroup.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.type';
		param.title='Type Definition Detail';
		param.title.style.bold='true';
		param.description='${include help/params/doc.comp.type.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.type.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.type.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.comp.type.for.element.type';
		param.title='Elements With Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.type.for.element.type.htm}';
		param.type='enum';
		param.enum.values='anonymous;any;none';
	}
	PARAM={
		param.name='doc.comp.type.for.attribute.type';
		param.title='Attributes With Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.type.for.attribute.type.htm}';
		param.type='enum';
		param.enum.values='anonymous;any;none';
	}
	PARAM={
		param.name='doc.comp.type.for.type';
		param.title='Global Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.type.for.type.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.type.deriv.tree';
		param.title='Type Derivation Tree';
		param.description='${include help/params/doc.comp.type.deriv.tree.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.type.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.comp.type.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.type.deriv.simpleContent';
		param.title='Simple Content Derivation';
		param.description='${include help/params/doc.comp.type.deriv.simpleContent.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='local;full;none';
		param.enum.displayValues='local definition only;full;none';
	}
	PARAM={
		param.name='doc.comp.type.deriv.simpleContent.facets';
		param.title='Facets';
		param.description='${include help/params/doc.comp.type.deriv.simpleContent.facets.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.type.deriv.simpleContent.annotations';
		param.title='Annotations';
		param.description='${include help/params/doc.comp.type.deriv.simpleContent.annotations.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.xml';
		param.title='XML Source';
		param.title.style.bold='true';
		param.description='${include help/params/doc.comp.xml.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.xml.box';
		param.title='Enclose in Box';
		param.description='${include help/params/doc.comp.xml.box.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.xml.remove.anns';
		param.title='Remove Annotations';
		param.description='${include help/params/doc.comp.xml.remove.anns.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes';
		param.title='Attribute Detail';
		param.title.style.bold='true';
		param.description='${include help/params/doc.comp.attributes.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.comp.attributes.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.for.element.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.for.complexType';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.for.complexType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.for.attributeGroup';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.for.attributeGroup.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.include';
		param.title='Include';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.include.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.comp.attributes.include.local';
		param.title='Local';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.include.local.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.include.references';
		param.title='References';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.include.references.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.include.wildcard';
		param.title='Wildcard';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.include.wildcard.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.include.prohibitions';
		param.title='Prohibitions';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.include.prohibitions.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.include.inherited';
		param.title='Inherited';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.include.inherited.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.comp.attributes.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.sorting.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.profile';
		param.title='Profile';
		param.description='${include help/params/doc.comp.attributes.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.profile.form';
		param.title='Form';
		param.description='${include help/params/doc.comp.attributes.profile.form.htm}';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue='non_default';
	}
	PARAM={
		param.name='doc.comp.attributes.profile.type';
		param.title='Type';
		param.description='${include help/params/doc.comp.attributes.profile.type.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.profile.use';
		param.title='Usage';
		param.description='${include help/params/doc.comp.attributes.profile.use.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.profile.default';
		param.title='Default Value';
		param.description='${include help/params/doc.comp.attributes.profile.default.htm}';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("doc.comp.attributes.value") ||
! getBooleanParam("doc.comp.attributes.value.default")';
	}
	PARAM={
		param.name='doc.comp.attributes.profile.fixed';
		param.title='Fixed Value';
		param.description='${include help/params/doc.comp.attributes.profile.fixed.htm}';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("doc.comp.attributes.value") ||
! getBooleanParam("doc.comp.attributes.value.fixed")';
	}
	PARAM={
		param.name='doc.comp.attributes.profile.defined';
		param.title='Definition Location';
		param.description='${include help/params/doc.comp.attributes.profile.defined.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.comp.attributes.include.inherited")';
	}
	PARAM={
		param.name='doc.comp.attributes.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.comp.attributes.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.value';
		param.title='Attribute Value';
		param.description='${include help/params/doc.comp.attributes.value.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.value.model';
		param.title='Datatype Model';
		param.description='${include help/params/doc.comp.attributes.value.model.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.value.restrictions';
		param.title='Restrictions';
		param.description='${include help/params/doc.comp.attributes.value.restrictions.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.value.restrictions.annotation';
		param.title='Annotations';
		param.description='${include help/params/doc.comp.attributes.value.restrictions.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.value.default';
		param.title='Default Value';
		param.description='${include help/params/doc.comp.attributes.value.default.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.value.fixed';
		param.title='Fixed Value';
		param.description='${include help/params/doc.comp.attributes.value.fixed.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.type';
		param.title='Type Detail';
		param.description='${include help/params/doc.comp.attributes.type.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.type.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.type.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.comp.attributes.type.for.attr';
		param.title='Attributes';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.type.for.attr.htm}';
		param.type='enum';
		param.enum.values='local;any';
		param.enum.displayValues='local only;any';
	}
	PARAM={
		param.name='doc.comp.attributes.type.for.typeDecl';
		param.title='Type Declarations';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.attributes.type.for.typeDecl.htm}';
		param.type='enum';
		param.enum.values='anonymous;any';
	}
	PARAM={
		param.name='doc.comp.attributes.type.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.comp.attributes.type.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.type.deriv.tree';
		param.title='Type Derivation Tree';
		param.description='${include help/params/doc.comp.attributes.type.deriv.tree.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.type.deriv.simpleContent';
		param.title='Simple Content Derivation';
		param.description='${include help/params/doc.comp.attributes.type.deriv.simpleContent.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='local;full;none';
		param.enum.displayValues='local definition only;full;none';
	}
	PARAM={
		param.name='doc.comp.attributes.type.deriv.simpleContent.facets';
		param.title='Facets';
		param.description='${include help/params/doc.comp.attributes.type.deriv.simpleContent.facets.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.type.deriv.simpleContent.annotations';
		param.title='Annotations';
		param.description='${include help/params/doc.comp.attributes.type.deriv.simpleContent.annotations.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.xml';
		param.title='XML Source';
		param.description='${include help/params/doc.comp.attributes.xml.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.xml.box';
		param.title='Enclose in Box';
		param.description='${include help/params/doc.comp.attributes.xml.box.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.attributes.xml.remove.anns';
		param.title='Remove Annotations';
		param.description='${include help/params/doc.comp.attributes.xml.remove.anns.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements';
		param.title='Content Element Detail';
		param.title.style.bold='true';
		param.description='${include help/params/doc.comp.contentElements.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.for.element.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.for.complexType';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.for.complexType.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.for.group';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.for.group.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.include';
		param.title='Include';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.include.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.include.local';
		param.title='Local';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.include.local.htm}';
		param.type='enum';
		param.enum.values='all;simpleType;none';
		param.enum.displayValues='all;with simple type only;none';
	}
	PARAM={
		param.name='doc.comp.contentElements.include.references';
		param.title='References';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.include.references.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.include.wildcards';
		param.title='Wildcards';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.include.wildcards.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.include.inherited';
		param.title='Inherited';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.include.inherited.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.comp.contentElements.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.sorting.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile';
		param.title='Profile';
		param.description='${include help/params/doc.comp.contentElements.profile.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.form';
		param.title='Form';
		param.description='${include help/params/doc.comp.contentElements.profile.form.htm}';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue='non_default';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.type';
		param.title='Type';
		param.description='${include help/params/doc.comp.contentElements.profile.type.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.abstract';
		param.title='Abstract';
		param.description='${include help/params/doc.comp.contentElements.profile.abstract.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.block';
		param.title='Block';
		param.description='${include help/params/doc.comp.contentElements.profile.block.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue='non_default';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.block.value';
		param.title='Value';
		param.description='${include help/params/doc.comp.contentElements.profile.block.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.block.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.comp.contentElements.profile.block.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.final';
		param.title='Final';
		param.description='${include help/params/doc.comp.contentElements.profile.final.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
		param.defaultValue='non_default';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.final.value';
		param.title='Value';
		param.description='${include help/params/doc.comp.contentElements.profile.final.value.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.final.meaning';
		param.title='Meaning';
		param.description='${include help/params/doc.comp.contentElements.profile.final.meaning.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.subst';
		param.title='Subst.Gr';
		param.description='${include help/params/doc.comp.contentElements.profile.subst.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.subst.heads';
		param.title='List of group heads';
		param.description='${include help/params/doc.comp.contentElements.profile.subst.heads.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.subst.members';
		param.title='List of group members';
		param.description='${include help/params/doc.comp.contentElements.profile.subst.members.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.default';
		param.title='Default Value';
		param.description='${include help/params/doc.comp.contentElements.profile.default.htm}';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("doc.comp.contentElements.simpleContent") ||
! getBooleanParam("doc.comp.contentElements.simpleContent.default")';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.fixed';
		param.title='Fixed Value';
		param.description='${include help/params/doc.comp.contentElements.profile.fixed.htm}';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("doc.comp.contentElements.simpleContent") ||
! getBooleanParam("doc.comp.contentElements.simpleContent.fixed")';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.nillable';
		param.title='Nillable';
		param.description='${include help/params/doc.comp.contentElements.profile.nillable.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.profile.defined';
		param.title='Definition Location';
		param.description='${include help/params/doc.comp.contentElements.profile.defined.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("doc.comp.contentElements.include.inherited")';
	}
	PARAM={
		param.name='doc.comp.contentElements.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.comp.contentElements.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.xmlRep';
		param.title='XML Representation Summary';
		param.description='${include help/params/doc.comp.contentElements.xmlRep.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("gen.doc.element") ||
! hasParamValue("gen.doc.element.local", "all")';
	}
	PARAM={
		param.name='doc.comp.contentElements.xmlRep.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.xmlRep.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.xmlRep.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.xmlRep.for.element.htm}';
		param.type='enum';
		param.enum.values='local;any';
		param.enum.displayValues='local only;any';
		param.defaultValue.expr='getBooleanParam("gen.doc.element") ? "local" : "any"';
	}
	PARAM={
		param.name='doc.comp.contentElements.xmlRep.for.type';
		param.title='With Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.xmlRep.for.type.htm}';
		param.type='enum';
		param.enum.values='complexType;simpleType;any';
		param.enum.displayValues='complex type;simple type;any type';
		param.defaultValue.expr='hasParamValue("gen.doc.element.local", "complexType") ?
 "simpleType" : "any"';
	}
	PARAM={
		param.name='doc.comp.contentElements.xmlRep.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.xmlRep.sorting.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.xmlRep.heading';
		param.title='Show Heading';
		param.description='${include help/params/doc.comp.contentElements.xmlRep.heading.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.simpleContent';
		param.title='Simple Content';
		param.description='${include help/params/doc.comp.contentElements.simpleContent.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.simpleContent.model';
		param.title='Datatype Model';
		param.description='${include help/params/doc.comp.contentElements.simpleContent.model.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.simpleContent.restrictions';
		param.title='Restrictions';
		param.description='${include help/params/doc.comp.contentElements.simpleContent.restrictions.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.simpleContent.restrictions.annotation';
		param.title='Annotations';
		param.description='${include help/params/doc.comp.contentElements.simpleContent.restrictions.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.simpleContent.default';
		param.title='Default Value';
		param.description='${include help/params/doc.comp.contentElements.simpleContent.default.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.simpleContent.fixed';
		param.title='Fixed Value';
		param.description='${include help/params/doc.comp.contentElements.simpleContent.fixed.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.type';
		param.title='Type Detail';
		param.description='${include help/params/doc.comp.contentElements.type.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
		param.defaultValue.expr='! getBooleanParam("gen.doc.element") ||
! hasParamValue("gen.doc.element.local", "all")';
	}
	PARAM={
		param.name='doc.comp.contentElements.type.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.type.for.htm}';
		param.group='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.type.for.element';
		param.title='Elements';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.type.for.element.htm}';
		param.type='enum';
		param.enum.values='local;any';
		param.enum.displayValues='local only;any';
		param.defaultValue.expr='getBooleanParam("gen.doc.element") ? "local" : "any"';
	}
	PARAM={
		param.name='doc.comp.contentElements.type.for.type';
		param.title='Types';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.type.for.type.htm}';
		param.type='enum';
		param.enum.values='simpleType;any';
		param.enum.displayValues='simple type;any';
		param.defaultValue.expr='getBooleanParam("gen.doc.element") &&
  hasParamValue("gen.doc.element.local", "complexType")
? "simpleType" : "any"';
	}
	PARAM={
		param.name='doc.comp.contentElements.type.for.typeDecl';
		param.title='Type Declarations';
		param.title.style.italic='true';
		param.description='${include help/params/doc.comp.contentElements.type.for.typeDecl.htm}';
		param.type='enum';
		param.enum.values='anonymous;any';
	}
	PARAM={
		param.name='doc.comp.contentElements.type.annotation';
		param.title='Annotation';
		param.description='${include help/params/doc.comp.contentElements.type.annotation.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.type.deriv.tree';
		param.title='Type Derivation Tree';
		param.description='${include help/params/doc.comp.contentElements.type.deriv.tree.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.type.deriv.simpleContent';
		param.title='Simple Content Derivation';
		param.description='${include help/params/doc.comp.contentElements.type.deriv.simpleContent.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='local;full;none';
		param.enum.displayValues='local definition only;full;none';
	}
	PARAM={
		param.name='doc.comp.contentElements.type.deriv.simpleContent.facets';
		param.title='Facets';
		param.description='${include help/params/doc.comp.contentElements.type.deriv.simpleContent.facets.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.type.deriv.simpleContent.annotations';
		param.title='Annotations';
		param.description='${include help/params/doc.comp.contentElements.type.deriv.simpleContent.annotations.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.xml';
		param.title='XML Source';
		param.description='${include help/params/doc.comp.contentElements.xml.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.xml.box';
		param.title='Enclose in Box';
		param.description='${include help/params/doc.comp.contentElements.xml.box.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='doc.comp.contentElements.xml.remove.anns';
		param.title='Remove Annotations';
		param.description='${include help/params/doc.comp.contentElements.xml.remove.anns.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='nav';
		param.title='Navigation';
		param.title.style.bold='true';
		param.description='${include help/params/nav.htm}';
		param.group='true';
	}
	PARAM={
		param.name='nav.overviewFrame';
		param.title='Overview Frame';
		param.description='${include help/params/nav.overviewFrame.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='nav.overviewFrame.title';
		param.title='Title';
		param.description='${include help/params/nav.overviewFrame.title.htm}';
		param.type='string';
		param.defaultValue.expr='getStringParam("docTitle")';
	}
	PARAM={
		param.name='nav.listFrame';
		param.title='List Frame';
		param.title.style.bold='true';
		param.description='${include help/params/nav.listFrame.htm}';
		param.group='true';
		param.type='enum';
		param.enum.values='allcomps;namespace;schema';
		param.enum.displayValues='All Components;Namespace;Schema';
	}
	PARAM={
		param.name='nav.listFrame.toc';
		param.title='Table of Contents';
		param.description='${include help/params/nav.listFrame.toc.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='nav.listFrame.allcomps';
		param.title='All Components';
		param.title.style.bold='true';
		param.description='${include help/params/nav.listFrame.allcomps.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.allcomps")
||
! getBooleanParam("gen.doc.namespace")
&&
! getBooleanParam("gen.doc.schema")';
	}
	PARAM={
		param.name='nav.listFrame.allcomps.linkTo';
		param.title='Link To';
		param.title.style.italic='true';
		param.description='${include help/params/nav.listFrame.allcomps.linkTo.htm}';
		param.type='enum';
		param.enum.values='details;xml_source';
		param.enum.displayValues='Component Details;XML Source';
	}
	PARAM={
		param.name='nav.listFrame.allcomps.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/nav.listFrame.allcomps.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.sorting.comps")';
	}
	PARAM={
		param.name='nav.listFrame.allcomps.elements';
		param.title='Elements';
		param.description='${include help/params/nav.listFrame.allcomps.elements.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.element")';
	}
	PARAM={
		param.name='nav.listFrame.allcomps.elements.local';
		param.title='Local Elements';
		param.description='${include help/params/nav.listFrame.allcomps.elements.local.htm}';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type;none';
		param.defaultValue.expr='getStringParam("gen.doc.element.local")';
	}
	PARAM={
		param.name='nav.listFrame.allcomps.complexTypes';
		param.title='Complex Types';
		param.description='${include help/params/nav.listFrame.allcomps.complexTypes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.complexType")';
	}
	PARAM={
		param.name='nav.listFrame.allcomps.simpleTypes';
		param.title='Simple Types';
		param.description='${include help/params/nav.listFrame.allcomps.simpleTypes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.simpleType")';
	}
	PARAM={
		param.name='nav.listFrame.allcomps.groups';
		param.title='Element Groups';
		param.description='${include help/params/nav.listFrame.allcomps.groups.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.group")';
	}
	PARAM={
		param.name='nav.listFrame.allcomps.attributeGroups';
		param.title='Attribute Groups';
		param.description='${include help/params/nav.listFrame.allcomps.attributeGroups.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.attributeGroup")';
	}
	PARAM={
		param.name='nav.listFrame.allcomps.attributes';
		param.title='Global Attributes';
		param.description='${include help/params/nav.listFrame.allcomps.attributes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.attribute")';
	}
	PARAM={
		param.name='nav.listFrame.namespace';
		param.title='Namespace';
		param.title.style.bold='true';
		param.description='${include help/params/nav.listFrame.namespace.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.namespace")';
	}
	PARAM={
		param.name='nav.listFrame.namespace.linkTo';
		param.title='Link To';
		param.title.style.italic='true';
		param.description='${include help/params/nav.listFrame.allcomps.linkTo.htm}';
		param.type='enum';
		param.enum.values='details;xml_source';
		param.enum.displayValues='Component Details;XML Source';
	}
	PARAM={
		param.name='nav.listFrame.namespace.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/nav.listFrame.allcomps.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.sorting.comps")';
	}
	PARAM={
		param.name='nav.listFrame.namespace.schemas';
		param.title='Schemas';
		param.description='${include help/params/nav.listFrame.namespace.schemas.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.schema")';
	}
	PARAM={
		param.name='nav.listFrame.namespace.elements';
		param.title='Elements';
		param.description='${include help/params/nav.listFrame.allcomps.elements.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.element")';
	}
	PARAM={
		param.name='nav.listFrame.namespace.elements.local';
		param.title='Local Elements';
		param.description='${include help/params/nav.listFrame.allcomps.elements.local.htm}';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type;none';
		param.defaultValue.expr='getStringParam("gen.doc.element.local")';
	}
	PARAM={
		param.name='nav.listFrame.namespace.complexTypes';
		param.title='Complex Types';
		param.description='${include help/params/nav.listFrame.allcomps.complexTypes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.complexType")';
	}
	PARAM={
		param.name='nav.listFrame.namespace.simpleTypes';
		param.title='Simple Types';
		param.description='${include help/params/nav.listFrame.allcomps.simpleTypes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.simpleType")';
	}
	PARAM={
		param.name='nav.listFrame.namespace.groups';
		param.title='Element Groups';
		param.description='${include help/params/nav.listFrame.allcomps.groups.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.group")';
	}
	PARAM={
		param.name='nav.listFrame.namespace.attributeGroups';
		param.title='Attribute Groups';
		param.description='${include help/params/nav.listFrame.allcomps.attributeGroups.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.attributeGroup")';
	}
	PARAM={
		param.name='nav.listFrame.namespace.attributes';
		param.title='Global Attributes';
		param.description='${include help/params/nav.listFrame.allcomps.attributes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.attribute")';
	}
	PARAM={
		param.name='nav.listFrame.schema';
		param.title='Schema';
		param.title.style.bold='true';
		param.description='${include help/params/nav.listFrame.schema.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.schema")';
	}
	PARAM={
		param.name='nav.listFrame.schema.linkTo';
		param.title='Link To';
		param.title.style.italic='true';
		param.description='${include help/params/nav.listFrame.allcomps.linkTo.htm}';
		param.type='enum';
		param.enum.values='details;xml_source';
		param.enum.displayValues='Component Details;XML Source';
	}
	PARAM={
		param.name='nav.listFrame.schema.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.description='${include help/params/nav.listFrame.allcomps.sorting.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.sorting.comps")';
	}
	PARAM={
		param.name='nav.listFrame.schema.elements';
		param.title='Elements';
		param.description='${include help/params/nav.listFrame.allcomps.elements.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.element")';
	}
	PARAM={
		param.name='nav.listFrame.schema.elements.local';
		param.title='Local Elements';
		param.description='${include help/params/nav.listFrame.allcomps.elements.local.htm}';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type;none';
		param.defaultValue.expr='getStringParam("gen.doc.element.local")';
	}
	PARAM={
		param.name='nav.listFrame.schema.complexTypes';
		param.title='Complex Types';
		param.description='${include help/params/nav.listFrame.allcomps.complexTypes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.complexType")';
	}
	PARAM={
		param.name='nav.listFrame.schema.simpleTypes';
		param.title='Simple Types';
		param.description='${include help/params/nav.listFrame.allcomps.simpleTypes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.simpleType")';
	}
	PARAM={
		param.name='nav.listFrame.schema.groups';
		param.title='Element Groups';
		param.description='${include help/params/nav.listFrame.allcomps.groups.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.group")';
	}
	PARAM={
		param.name='nav.listFrame.schema.attributeGroups';
		param.title='Attribute Groups';
		param.description='${include help/params/nav.listFrame.allcomps.attributeGroups.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.attributeGroup")';
	}
	PARAM={
		param.name='nav.listFrame.schema.attributes';
		param.title='Global Attributes';
		param.description='${include help/params/nav.listFrame.allcomps.attributes.htm}';
		param.type='boolean';
		param.defaultValue.expr='getBooleanParam("gen.doc.attribute")';
	}
	PARAM={
		param.name='nav.detailFrame';
		param.title='Detail Frame';
		param.description='${include help/params/nav.detailFrame.htm}';
		param.type='enum';
		param.enum.values='overview;allcomps;namespace;schema';
		param.enum.displayValues='Overview Summary;All Component Summary;Namespace Overview;Schema Overview';
	}
	PARAM={
		param.name='show';
		param.title='Show';
		param.title.style.bold='true';
		param.description='${include help/params/show.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='show.linkTitle';
		param.title='Link Titles (Tooltips)';
		param.description='${include help/params/show.linkTitle.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='show.linkTitle.name';
		param.title='Component Name';
		param.description='${include help/params/show.linkTitle.name.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='show.linkTitle.namespace';
		param.title='Namespace URI';
		param.description='${include help/params/show.linkTitle.namespace.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='show.linkTitle.schema';
		param.title='Defined in Schema';
		param.description='${include help/params/show.linkTitle.schema.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='show.fileLocation';
		param.title='File Locations';
		param.description='${include help/params/show.fileLocation.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='show.fileLocation.relative';
		param.title='Relative Path';
		param.description='${include help/params/show.fileLocation.relative.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='show.fileLocation.hyperlink';
		param.title='Hyperlink';
		param.description='${include help/params/show.fileLocation.hyperlink.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='show.nsPrefix';
		param.title='Namespace Prefixes';
		param.description='${include help/params/show.nsPrefix.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='show.elementNameExt';
		param.title='Element Name Extensions';
		param.description='${include help/params/show.elementNameExt.htm}';
		param.type='enum';
		param.enum.values='always;repeating;never';
		param.enum.displayValues='always;for repeating names only;never';
		param.defaultValue='repeating';
	}
	PARAM={
		param.name='proc';
		param.title='Processing';
		param.title.style.bold='true';
		param.description='${include help/params/proc.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='proc.annotation';
		param.title='Annotations';
		param.title.style.bold='true';
		param.description='${include help/params/proc.annotation.htm}';
		param.group='true';
	}
	PARAM={
		param.name='proc.annotation.appinfo';
		param.title='<appinfo>';
		param.title.style.bold='true';
		param.description='${include help/params/proc.annotation.appinfo.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
	}
	PARAM={
		param.name='proc.annotation.appinfo.source';
		param.title='Source URI';
		param.description='${include help/params/proc.annotation.appinfo.source.htm}';
		param.type='enum';
		param.enum.values='as_see_link;as_title;no';
		param.enum.displayValues='document as see-link;document as annotation title;no processing';
	}
	PARAM={
		param.name='proc.annotation.documentation';
		param.title='<documentation>';
		param.title.style.bold='true';
		param.description='${include help/params/proc.annotation.documentation.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='proc.annotation.documentation.lang';
		param.title='Language';
		param.description='${include help/params/proc.annotation.documentation.lang.htm}';
		param.group='true';
		param.group.enablingExpr='! getArrayParam("").isEmpty()';
		param.type='string';
		param.trimSpaces='true';
		param.noEmptyString='true';
		param.list='true';
		param.list.noEmptyList='true';
	}
	PARAM={
		param.name='proc.annotation.documentation.lang.alt';
		param.title='Alternative Language';
		param.description='${include help/params/proc.annotation.documentation.lang.alt.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.noEmptyString='true';
		param.list='true';
		param.list.noEmptyList='true';
	}
	PARAM={
		param.name='proc.annotation.documentation.source';
		param.title='Source URI';
		param.description='${include help/params/proc.annotation.documentation.source.htm}';
		param.type='enum';
		param.enum.values='as_see_link;as_title;no';
		param.enum.displayValues='document as see-link;document as annotation title;no processing';
	}
	PARAM={
		param.name='proc.annotation.tags';
		param.title='Tags';
		param.title.style.bold='true';
		param.description='${include help/params/proc.annotation.tags.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='proc.annotation.tags.xhtml';
		param.title='XHTML';
		param.description='${include help/params/proc.annotation.tags.xhtml.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='proc.annotation.tags.xhtml.schemas';
		param.title='For schemas';
		param.title.style.italic='true';
		param.description='${include help/params/proc.annotation.tags.xhtml.schemas.htm}';
		param.group='true';
	}
	PARAM={
		param.name='proc.annotation.tags.xhtml.schemas.include';
		param.title='Include';
		param.title.style.italic='true';
		param.description='${include help/params/proc.annotation.tags.xhtml.schemas.include.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='proc.annotation.tags.xhtml.schemas.exclude';
		param.title='Exclude';
		param.title.style.italic='true';
		param.description='${include help/params/proc.annotation.tags.xhtml.schemas.exclude.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='proc.annotation.tags.xhtml.images';
		param.title='Include Images';
		param.description='${include help/params/proc.annotation.tags.xhtml.images.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='proc.annotation.tags.xhtml.images.copy';
		param.title='Copy Images';
		param.description='${include help/params/proc.annotation.tags.xhtml.images.copy.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='proc.annotation.tags.other';
		param.title='Other Tags';
		param.description='${include help/params/proc.annotation.tags.other.htm}';
		param.type='enum';
		param.enum.values='show;xhtml;no';
		param.enum.displayValues='show;process as XHTML;no processing';
	}
	PARAM={
		param.name='proc.annotation.encode.markup.chars';
		param.title='Encode markup characters';
		param.description='${include help/params/proc.annotation.encode.markup.chars.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='proc.annotation.show.part.headings';
		param.title='Show part headings';
		param.description='${include help/params/proc.annotation.show.part.headings.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='proc.annotation.show.part.headings.schemas';
		param.title='For schemas';
		param.title.style.italic='true';
		param.description='${include help/params/proc.annotation.show.part.headings.schemas.htm}';
		param.group='true';
	}
	PARAM={
		param.name='proc.annotation.show.part.headings.schemas.include';
		param.title='Include';
		param.title.style.italic='true';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='proc.annotation.show.part.headings.schemas.exclude';
		param.title='Exclude';
		param.title.style.italic='true';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
	}
	PARAM={
		param.name='DiagramKit';
		param.title='DiagramKit';
		param.title.style.bold='true';
		param.description='${include help/params/DiagramKit.htm}';
		param.enablingExpr='dsmType.imageProvider.name == "DiagramKit"';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='getBooleanParam("")';
		param.type='boolean';
		param.defaultValue.expr='dsmType.imageProvider.name == "DiagramKit"';
	}
	PARAM={
		param.name='DiagramKit.show';
		param.title='Show in Diagram';
		param.title.style.bold='true';
		param.description='${include help/params/DiagramKit.show.htm}';
		param.group='true';
	}
	PARAM={
		param.name='DiagramKit.show.annotation';
		param.title='Annotations';
		param.title.style.bold='true';
		param.description='${include help/params/DiagramKit.show.annotation.htm}';
		param.group='true';
		param.group.enablingExpr='! hasParamValue("", "none")';
		param.type='enum';
		param.enum.values='none;first_sentence;full';
		param.enum.displayValues='none;first sentence;full';
		param.defaultValue='first_sentence';
	}
	PARAM={
		param.name='DiagramKit.show.annotation.renderLineBreaks';
		param.title='Render Line Breaks';
		param.description='${include help/params/DiagramKit.show.annotation.renderLineBreaks.htm}';
		param.type='boolean';
	}
	PARAM={
		param.name='DiagramKit.show.annotation.wrap';
		param.title='Wrapping';
		param.description='${include help/params/DiagramKit.show.annotation.wrap.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='DiagramKit.show.annotation.wrap.optimize';
		param.title='Optimize';
		param.description='${include help/params/DiagramKit.show.annotation.wrap.optimize.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='DiagramKit.show.annotation.wrap.minWidth';
		param.title='Minimal Width';
		param.description='${include help/params/DiagramKit.show.annotation.wrap.minWidth.htm}';
		param.type='integer';
		param.type.units='(px)';
		param.defaultValue='120';
	}
	PARAM={
		param.name='DiagramKit.show.annotation.wrap.maxWidth';
		param.title='Maximal Width';
		param.description='${include help/params/DiagramKit.show.annotation.wrap.maxWidth.htm}';
		param.enablingExpr='getBooleanParam("DiagramKit.show.annotation.wrap.optimize")';
		param.type='integer';
		param.type.units='(px)';
		param.defaultValue.expr='getIntParam("DiagramKit.layout.node.maxWidth")';
	}
	PARAM={
		param.name='DiagramKit.show.properties';
		param.title='Properties';
		param.title.style.bold='true';
		param.description='${include help/params/DiagramKit.show.properties.htm}';
		param.group='true';
		param.group.enablingExpr='getBooleanParam()';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='DiagramKit.show.properties.element';
		param.title='Element';
		param.description='${include help/params/DiagramKit.show.properties.element.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='getBooleanParam()';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='DiagramKit.show.properties.element.rows';
		param.title='Rows';
		param.description='${include help/params/DiagramKit.show.properties.element.rows.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
		param.defaultValue='id;type;derivedBy;content;mixed;form;nillable;final;block;substGrp;substWith;enum;pattern;length;minLen/maxLen:"min/maxLen";minIncl/maxIncl:"min/maxIncl";minExcl/maxExcl:"min/maxExcl";totalDig;fracDig;whiteSp;default;fixed';
	}
	PARAM={
		param.name='DiagramKit.show.properties.attribute';
		param.title='Attibute';
		param.description='${include help/params/DiagramKit.show.properties.attribute.htm}';
		param.group='true';
		param.group.defaultState='expanded';
		param.group.enablingExpr='getBooleanParam()';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='DiagramKit.show.properties.attribute.rows';
		param.title='Rows';
		param.description='${include help/params/DiagramKit.show.properties.attribute.rows.htm}';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
		param.list='true';
		param.defaultValue='id;form;type;derivedBy;use;enum;pattern;length;minLen/maxLen:"min/maxLen";minIncl/maxIncl:"min/maxIncl";minExcl/maxExcl:"min/maxExcl";totalDig;fracDig;whiteSp;default;fixed';
	}
	PARAM={
		param.name='DiagramKit.show.properties.value';
		param.title='Values';
		param.description='${include help/params/DiagramKit.show.properties.value.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='DiagramKit.show.properties.value.separator';
		param.title='List Separator';
		param.description='${include help/params/DiagramKit.show.properties.value.separator.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='DiagramKit.show.properties.value.separator.enum';
		param.title='Enumeration';
		param.description='${include help/params/DiagramKit.show.properties.value.separator.enum.htm}';
		param.type='string';
		param.defaultValue=', ';
	}
	PARAM={
		param.name='DiagramKit.show.properties.value.separator.pattern';
		param.title='Pattern';
		param.description='${include help/params/DiagramKit.show.properties.value.separator.pattern.htm}';
		param.type='string';
		param.defaultValue=' ';
	}
	PARAM={
		param.name='DiagramKit.show.properties.value.equalColumnWidths';
		param.title='Equal Column Widths';
		param.description='${include help/params/DiagramKit.show.properties.value.equalColumnWidths.htm}';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='DiagramKit.show.substGroup';
		param.title='Substitution Groups';
		param.description='${include help/params/DiagramKit.show.substGroup.htm}';
		param.type='enum';
		param.enum.values='always;by_root_only;none';
		param.enum.displayValues='always;by diagram root only;none';
	}
	PARAM={
		param.name='DiagramKit.layout';
		param.title='Layout';
		param.title.style.bold='true';
		param.description='${include help/params/DiagramKit.layout.htm}';
		param.group='true';
	}
	PARAM={
		param.name='DiagramKit.layout.node';
		param.title='Nodes';
		param.description='${include help/params/DiagramKit.layout.node.htm}';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='DiagramKit.layout.node.minWidth';
		param.title='Minimal Width';
		param.description='${include help/params/DiagramKit.layout.node.minWidth.htm}';
		param.type='integer';
		param.type.nonNegative='true';
		param.type.units='(px)';
		param.defaultValue='50';
	}
	PARAM={
		param.name='DiagramKit.layout.node.maxWidth';
		param.title='Maximal Width';
		param.description='${include help/params/DiagramKit.layout.node.maxWidth.htm}';
		param.type='integer';
		param.type.nonNegative='true';
		param.type.units='(px)';
		param.defaultValue='350';
	}
	PARAM={
		param.name='DiagramKit.style';
		param.title='Styling';
		param.title.style.bold='true';
		param.description='${include help/params/DiagramKit.style.htm}';
		param.group='true';
	}
	PARAM={
		param.name='DiagramKit.style.baseType';
		param.title='Base Type Panel';
		param.description='${include help/params/DiagramKit.style.baseType.htm}';
		param.group='true';
	}
	PARAM={
		param.name='DiagramKit.style.baseType.caption.color';
		param.title='Caption Color';
		param.description='${include help/params/DiagramKit.style.baseType.caption.color.htm}';
		param.type='Color';
		param.defaultValue='#6B758C';
	}
	PARAM={
		param.name='DiagramKit.style.baseType.bkgr.color';
		param.title='Background';
		param.description='${include help/params/DiagramKit.style.baseType.bkgr.color.htm}';
		param.type='Color';
		param.defaultValue='#DEE7FF';
	}
	PARAM={
		param.name='DiagramKit.style.baseType.border.color';
		param.title='Border Color';
		param.description='${include help/params/DiagramKit.style.baseType.border.color.htm}';
		param.type='Color';
		param.defaultValue='#808080';
	}
	PARAM={
		param.name='DiagramKit.style.annotation';
		param.title='Annotations';
		param.description='${include help/params/DiagramKit.style.annotation.htm}';
		param.group='true';
	}
	PARAM={
		param.name='DiagramKit.style.annotation.color';
		param.title='Color';
		param.description='${include help/params/DiagramKit.style.annotation.color.htm}';
		param.type='Color';
		param.defaultValue='#808080';
	}
</TEMPLATE_PARAMS>
<STYLES>
	TABLE_STYLE={
		style.name='About Box';
		style.id='ts1';
		style.description='Specifies border and background of "About" section added at the bottom of each generated document';
		style.css.className='aboutBox';
		table.cell.padding.both='2.5';
		table.bkgr.color='#E7EDF6';
		table.border.style='solid';
		table.border.color='#999999';
		table.border.css.render='true';
		table.page.keepTogether='true';
	}
	CHAR_STYLE={
		style.name='About Font';
		style.id='cs1';
		style.description='Specify text formatting of "About" section added at the bottom of each generated document';
		style.css.className='about';
		text.font.name='SansSerif';
		text.font.size='8.4';
	}
	HR_STYLE={
		style.name='About Separator';
		style.id='hrs1';
		style.description='Style of horizontal rule that separates "About" section';
		style.css.className='aboutRule';
		hr.lineStyle='dashed';
		hr.color='#999999';
		hr.margin.top='10';
	}
	CHAR_STYLE={
		style.name='Component List';
		style.id='cs2';
		style.description='Text formatting of various component lists, e.g.:
- Content Model Elements
- Known Direct Subtypes
etc.';
		style.css.className='compList';
		text.font.size='10';
	}
	CHAR_STYLE={
		style.name='Component List (Small)';
		style.id='cs3';
		style.description='Text formatting of component lists included in Content Element Details';
		style.css.className='compList-small';
		text.font.size='9';
	}
	PAR_STYLE={
		style.name='Component List Heading 1';
		style.id='ps1';
		style.description='Formats headings of separate component lists, e.g.: 
- Content Model Elements
- Included in content model of elements
- Known Direct Subtypes
etc.';
		style.css.className='compListHead1';
		text.font.size='10';
		text.font.style.bold='true';
		par.margin.top='10';
		par.margin.bottom='7';
	}
	PAR_STYLE={
		style.name='Component List Heading 2';
		style.id='ps2';
		style.description='Formats headings of component lists within Known Usage Locations report, e.g.: 
- Within global complexTypes
- Within anonymous complexTypes of elements
- Within model groups
etc.';
		style.css.className='compListHead2';
		text.font.size='9';
		text.font.style.bold='true';
		par.margin.bottom='7';
	}
	PAR_STYLE={
		style.name='Component List Heading 3';
		style.id='ps3';
		style.description='Formats headings of related component lists within Component Summary items';
		style.css.className='compListHead3';
		text.font.name='SansSerif';
		text.font.size='8';
		text.font.style.bold='true';
		text.color.background='#CCCCFF';
		text.color.opaque='true';
		par.margin.top='7';
		par.margin.bottom='5';
		par.page.keepWithNext='true';
	}
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs4';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Demo Excluded Message';
		style.id='cs5';
		style.css.className='demoExcl';
		text.font.style.italic='true';
		text.color.foreground='#FF0000';
	}
	CHAR_STYLE={
		style.name='Demo Excluded Message (Small)';
		style.id='cs6';
		style.css.className='demoExcl-small';
		text.font.size='9';
		text.font.style.italic='true';
		text.color.foreground='#FF0000';
	}
	CHAR_STYLE={
		style.name='Derivation Method';
		style.id='cs7';
		style.description='Formats little texts (typically, one or a few words) describing how a given XSD component was derived from others';
		style.css.className='derivMethod';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#FF9900';
	}
	PAR_STYLE={
		style.name='Derivation Tree Heading';
		style.id='ps4';
		style.description='Formats heading of Type Derivation Tree';
		style.css.className='derivTreeHead';
		text.font.size='9';
		text.font.style.bold='true';
		text.color.foreground='#990000';
		par.margin.bottom='6';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Derivation Tree Heading (Small)';
		style.id='ps5';
		style.description='Formats the heading of Type Derivation Tree (smaller version).

NOTE: Type Derivation Tree may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='derivTreeHead-small';
		text.font.size='8';
		text.font.style.bold='true';
		text.color.foreground='#990000';
		par.margin.bottom='6';
		par.page.keepWithNext='true';
	}
	CHAR_STYLE={
		style.name='Derivation Tree Method';
		style.id='cs8';
		style.description='Highlights a little text (typically 1-2 words) used in Type Derivation Tree to describe how a given type is derived from its ancestor.';
		style.css.className='derivTreeMethod';
		text.font.name='Verdana';
		text.font.size='7';
		text.color.foreground='#F59200';
	}
	CHAR_STYLE={
		style.name='Derivation Tree Method (Small)';
		style.id='cs9';
		style.description='Highlights a little text (typically 1-2 words) used in the smaller version of Type Derivation Tree to describe how a given type is derived from its ancestor.

NOTE: Type Derivation Tree may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='derivTreeMethod-small';
		text.font.name='Verdana';
		text.font.size='7';
		text.color.foreground='#F59200';
	}
	CHAR_STYLE={
		style.name='Derivation Tree Type';
		style.id='cs10';
		style.description='Formats type names in Type Derivation Tree.';
		style.css.className='derivTreeType';
		text.font.name='Monospaced';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='Derivation Tree Type (Small)';
		style.id='cs11';
		style.description='Formats type names in the smaller version of Type Derivation Tree.

NOTE: Type Derivation Tree may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='derivTreeType-small';
		text.font.name='Monospaced';
		text.font.size='7.5';
	}
	CHAR_STYLE={
		style.name='Description';
		style.id='cs12';
		style.description='The normal font for decriptions/annotations. Used for detailed descriptions of components documented globally as well as the descriptions of the whole XML schemas (on schema overview page).

NOTE: Although, this style is reserved here and applied across all sub-templates, it defines no properties, thereby allowing any default font. However, you can change that.';
		style.css.className='desc';
	}
	CHAR_STYLE={
		style.name='Description (Small)';
		style.id='cs13';
		style.description='The smaller font for decriptions/annotations. Used in summary tables and documentation of content component (e.g. XSD content elements/attributes).';
		style.css.className='desc-small';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='Description (Tiny)';
		style.id='cs14';
		style.description='The smalest font for decriptions/annotations. It is used, for instance, to format annotations of facets, which themselves are documented with a small font. Since the actual text size also depends on the font face (name), the font name in this style is fixed as \'Arial\' so as not to depend on the default browser font.';
		style.css.className='desc-tiny';
		text.font.name='SansSerif';
		text.font.size='8';
	}
	PAR_STYLE={
		style.name='Detail Heading 1';
		style.id='ps6';
		style.description='Formats top heading of each detail page, e.g.:
- Overview Summary
- Namespace Overview
- Schema Overview
- Component Documentation';
		style.css.className='head1';
		text.font.name='Verdana';
		text.font.size='13';
		text.font.style.bold='true';
		text.color.foreground='#4477AA';
		par.bkgr.opaque='true';
		par.bkgr.color='#EEEEEE';
		par.border.style='solid';
		par.border.color='#4477AA';
		par.margin.bottom='7';
		par.padding.left='4';
		par.padding.right='4';
		par.padding.top='3';
		par.padding.bottom='3';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 4';
		style.id='ps7';
		style.description='Formats headings of large sections of Component Documentation, e.g.:
- Description / Annotation
- XML Source
- Usage / Definition Locations
- Type (Definition) Detail
- Attribute Detail
- Content Element Detail';
		style.css.className='head4';
		text.font.size='12';
		text.font.style.bold='true';
		par.bkgr.opaque='true';
		par.bkgr.color='#CCCCFF';
		par.border.style='solid';
		par.border.color='#666666';
		par.margin.top='12';
		par.margin.bottom='8';
		par.padding.left='2';
		par.padding.right='2';
		par.padding.top='2';
		par.padding.bottom='2';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 5';
		style.id='ps8';
		style.description='Formats headings of sections that describe nested or referenced components (and other minor features) within main (global) Component Documentation, e.g.:

- Simple Content Detail (in Element / Complex Type / Simple Type / Global Atribute)';
		style.css.className='head5';
		text.font.size='10';
		text.font.style.bold='true';
		par.margin.top='10';
		par.margin.bottom='8';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 5 (Mono)';
		style.id='ps9';
		style.description='This style is similar to \'Detail Heading 5\' style, however it is used in cases when a monospaced font is preferable. It is applied to headings of the following sections:

- Attribute (in Attribute Detail in Element / Complex Type / Attribute Group)
- Element (in Content Element Details in Element / Complex Type / Element Group)';
		style.css.className='head5-mono';
		text.font.name='Monospaced';
		text.font.size='9';
		par.margin.top='10';
		par.margin.bottom='8';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 6';
		style.id='ps10';
		style.description='Formats headings in local documentation (these are sections that describe features of nested or referenced components within main/global Component Documentation), e.g.:

- XML Source, Attribute Value, Type Detail (in Attribute in Attribute Detail in Element / Complex Type / Attribute Group)
- XML Source, Component Diagram, XML Representation Summary, Simple Content, Possible Children, Type Detail (in Element in Content Element Details in Element / Complex Type / Element Group).

Many of those sections replicate similar sections of global component documentation. However, the local documentation is nested in it and, therefore, everything should be smaller.';
		style.css.className='head6';
		text.font.size='9';
		text.font.style.bold='true';
		text.font.style.italic='true';
		text.color.background='#CCCCFF';
		text.color.opaque='true';
		par.margin.top='8';
		par.margin.bottom='5';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 7';
		style.id='ps11';
		style.description='Formats heading used in simple type derivation details. That detail consists of a number of similarly organized sections nested in each other recursively (potentially at any depth). Every such a section has a heading, which is formatted with this style.';
		style.css.className='head7';
		text.font.name='SansSerif';
		text.font.size='8';
		text.font.style.bold='true';
		text.font.style.italic='true';
		text.color.background='#CCCCFF';
		text.color.opaque='true';
		par.margin.top='7';
		par.margin.bottom='7';
		par.page.keepWithNext='true';
	}
	HR_STYLE={
		style.name='Detail Separator';
		style.id='hrs2';
		style.description='Styles horizontal rules that separate various detail sections';
		style.css.className='rule';
		hr.lineStyle='dashed';
		hr.color='#999999';
		hr.margin.top='10';
		hr.margin.bottom='10';
	}
	PAR_STYLE={
		style.name='Diagram Heading';
		style.id='ps12';
		style.description='Heading of component diagram';
		style.css.className='diagramHead';
		text.font.style.bold='true';
		text.color.foreground='#990000';
		par.bkgr.opaque='true';
		par.bkgr.color='#F5F5F5';
		par.border.style='solid';
		par.border.color='#999999';
		par.padding.left='2.5';
		par.padding.right='2.5';
		par.padding.top='2.5';
		par.padding.bottom='2.5';
	}
	PAR_STYLE={
		style.name='Frame Heading 1';
		style.id='ps13';
		style.description='Formats top heading (title) of navigation List Frames';
		style.css.className='frameHead1';
		text.font.name='SansSerif';
		text.font.size='9.5';
		text.font.style.bold='true';
		par.margin.bottom='5.8';
		par.option.nowrap='true';
	}
	PAR_STYLE={
		style.name='Frame Heading 2';
		style.id='ps14';
		style.description='Formats group headings in navigation frames, e.g.: "Namespaces", "XML Schemas", "Elements".

NOTE: Some of such headings can be simultaneously latent hyperlinks (which reveal themselves only when mouse cursor hovers over the heading). So, when rendered in HTML, this style may produce two named CSS rules: one for <div> element (to format the heading paragraph) and other for <span> and <a> elements (to format the heading text and the hyperlink). At that, in case of hyperlink, any default hyperlink formatting must be suppressed and normal heading text formatting preserved. That is achieved by specifically setting: no underline; black color';
		style.css.className='frameHead2';
		text.font.name='SansSerif';
		text.font.size='9';
		text.font.style.bold='true';
		text.decor.underline='false';
		text.color.foreground='#000000';
		par.margin.top='6';
		par.margin.bottom='2.5';
		par.option.nowrap='true';
	}
	PAR_STYLE={
		style.name='Frame Heading 2 (Note)';
		style.id='ps15';
		style.description='Formats little texts added under group headings (in navigation frames) to provide some extra information about the group, e.g.: "(local elements unified by type)"';
		style.css.className='frameHead2-note';
		text.font.name='Tahoma';
		text.font.size='6';
		text.font.style.bold='true';
		text.color.foreground='#000000';
		par.margin.top='0';
		par.margin.bottom='3';
		par.option.nowrap='true';
	}
	PAR_STYLE={
		style.name='Frame Item';
		style.id='ps16';
		style.description='Formats list items in navigation frames';
		style.css.className='frameItem';
		text.font.name='SansSerif';
		text.font.size='9';
		par.option.nowrap='true';
	}
	TABLE_STYLE={
		style.name='Frame TOC Box';
		style.id='ts2';
		style.description='Styles border and background of Table Of Contents box in navigation List Frame';
		style.css.className='frameTOCBox';
		table.cell.padding.both='3';
		table.bkgr.color='#F5F5F5';
		table.border.style='solid';
		table.border.color='#999999';
		table.border.css.render='true';
	}
	PAR_STYLE={
		style.name='Frame TOC Heading';
		style.id='ps17';
		style.description='Formats heading in Table Of Contents box in navigation List Frame';
		style.css.className='frameTOCHead';
		text.font.name='SansSerif';
		text.font.size='7';
		text.font.style.bold='true';
		par.margin.bottom='2';
		par.option.nowrap='true';
	}
	PAR_STYLE={
		style.name='Frame TOC Item';
		style.id='ps18';
		style.description='Formats items in Table Of Contents box in navigation List Frame';
		style.css.className='frameTOCItem';
		text.font.name='SansSerif';
		text.font.size='8';
		par.option.nowrap='true';
	}
	CHAR_STYLE={
		style.name='Heading Note';
		style.id='cs15';
		style.description='Formats short texts added to some headings (styled with \'Detail Heading 4\' or \'Summary Heading\') to provide more info about the whole section.

For example:

HEADING TEXT: "XML Source"
HEADING NOTE: "(w/o annotations (1); see within schema source)"

HEADING TEXT: "Attribute Detail"
HEADING NOTE: "(all declarations; defined within this component only; 1/2)"

The note text must be rendered with a flat compact font to be far less promiminent than the heading text itself. The \'bold\' property is set unselected to neutralize the \'bold\' set for the whole heading.';
		style.css.className='headNote';
		text.font.size='8.4';
		text.font.style.bold='false';
		text.decor.underline='false';
		text.color.opaque='false';
		text.border.style='none';
	}
	CHAR_STYLE={
		style.name='Heading Note Separator';
		style.id='cs16';
		style.description='Formats the space character that separates heading note from the main heading text.

This style is the same as \'Heading Note\' style, but in addition the \'Character spacing\' property is specified to make the separator char wider.';
		style.css.className='headNoteSp';
		text.font.size='8.4';
		text.font.style.bold='false';
		text.decor.underline='false';
		text.color.opaque='false';
		text.border.style='none';
		text.spacing.letter='3';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs17';
	}
	CHAR_STYLE={
		style.name='Hyperlink (latent)';
		style.id='cs18';
		style.description='Used to format completely blended-in (latent) hyperlinks.

Certain hyperlinks must look completely the same as ordinary text and reveal themselves only when the mouse cursor hovers over such a link. This is achieved by formatting the hyperlink as normal text and adding to it some extra-formatting for hovering. This style provides that extra formatting. It just specifies the underlining. 

The blended-in formatting itself is achieved through the ordinary text style (acting at that location), which is repeated also as a separate CSS rule for <a> tag, so that its class selector is added to the hyperlink formatting classes.';
		style.css.className='latentLink';
		text.decor.underline='true';
	}
	CHAR_STYLE={
		style.name='Mono';
		style.id='cs19';
		style.description='Sets a monospaced font.

This style is used to format component names (to make them more readable/distinguishable).';
		style.css.className='mono';
		text.font.name='Monospaced';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='Mono (Small)';
		style.id='cs20';
		style.description='Sets a monospaced font of smaller size. 

This style is used to format component names (to make them more readable/distinguishable).';
		style.css.className='mono-small';
		text.font.name='Monospaced';
		text.font.size='7.5';
	}
	CHAR_STYLE={
		style.name='Name Extension';
		style.id='cs21';
		style.description='Formats extensions of component names.

Some XSD components may have repeating names. That is, several different components of the same type may share the same name within the same namespace. This may happen with locally defined element components and with redefinitions of complexTypes and groups. When such equally named components appear in the same documentation, they must be distinguished from each other. So, a special name extension is generated. Those name extensions may be quite long and should not overwhelm everything else (particularly in component lists). That is achieved by using small yet readable font and faded color, which are specified by this style.

NOTE: The name extension may include hyperlinks, which are formatted with the same font/color and highlighted only with underlining. So, in HTML this style may produce the same named CSS rule for both <span> element (to format text) and <a> element (to format hyperlinks, along with \'blended-in hyperlink\' style).';
		style.css.className='nameExt';
		text.font.name='Verdana';
		text.font.size='7';
		text.font.style.bold='false';
		text.color.foreground='#B2B2B2';
	}
	CHAR_STYLE={
		style.name='Name Extension Hyperlink';
		style.id='cs22';
		style.description='Styles hyperlinks from extensions of component names';
		style.css.className='nameExtLink';
		text.decor.underline='true';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='ps19';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Profile Item';
		style.id='cs23';
		style.description='Styles profile item values.

ABOUT PROFILES

Profile (in terms of this XML schema documentation) is a short summary about a particular large documented entity (e.g. schema, namespace) or group of entities (e.g. All Components). A profile consists of items, which include title, value and possible note (some explanation text).';
		style.css.className='profileItem';
		text.font.name='Verdana';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='Profile Item Note';
		style.id='cs24';
		style.description='Styles extra text added to profile item value to explain its meaning, e.g.:
(blocks any substitutions of elements through substitution groups)

ABOUT PROFILES

Profile (in terms of this XML schema documentation) is a short summary about a particular large documented entity (e.g. schema, namespace) or group of entities (e.g. All Components). A profile consists of items, which include title and value with possible note (some explanation text).';
		text.font.name='Tahoma';
		text.font.size='8';
		text.font.style.italic='true';
	}
	PAR_STYLE={
		style.name='Profile Item Title';
		style.id='ps20';
		style.description='Styles profile item titles.

NOTE: Some of such titles can be simultaneously latent hyperlinks (which reveal themselves only when mouse cursor hovers over the heading). So, when rendered in HTML, this style may produce two named CSS rules: one for <div> element (to format the title paragraph) and other for <span> and <a> elements (to format the title text and the hyperlink). At that, in case of hyperlink, any default hyperlink formatting must be suppressed and normal title formatting preserved. That is achieved by specifically setting: no underline; black color

ABOUT PROFILES

Profile (in terms of this XML schema documentation) is a short summary about a particular large documented entity (e.g. schema, namespace) or group of entities (e.g. All Components). A profile consists of items, which include title and value with possible note (some explanation text).';
		style.css.className='profileItemTitle';
		text.font.size='9';
		text.font.style.bold='true';
		text.decor.underline='false';
		text.color.foreground='#000000';
	}
	PAR_STYLE={
		style.name='Property Heading';
		style.id='ps21';
		style.description='This style is used to format property title, when the title + value won\'t fit well in a single table row, that is the representation of the property value may require to occupy as much of the available document/page width as possible. In that case, the property title is printed above and the value beneath of it.

ABOUT PROPERTIES

Properties (in terms of this XML schema documentation) are short pieces of information about particular documented entities (e.g. XSD components, facets etc.) Each property has a title and value.';
		style.css.className='propHead';
		text.font.size='8';
		text.font.style.bold='true';
		par.margin.bottom='3';
	}
	CHAR_STYLE={
		style.name='Property Note';
		style.id='cs25';
		style.description='Styles extra text added to property value to explain its meaning, e.g.:
"(blocks all substitutions of this element or its type)"';
		style.css.className='propNote';
		text.font.name='Tahoma';
		text.font.size='8';
		text.font.style.italic='true';
	}
	PAR_STYLE={
		style.name='Property Title';
		style.id='ps22';
		style.description='Styles property titles. Besides formatting of text, it specifies also a few paragraph settings to ensure necessary spacing between neighbouring rows and cells.

ABOUT PROPERTIES

Properties (in terms of this XML schema documentation) are short pieces of information about particular documented entities (e.g. XSD components, facets etc.) Each property has a title and value. The value may also include additional things, like:
- hyperlinks
- short explanations
- component derivation summary
- a short list of related components, schemas etc.
- a set of related properties (sub-properties)

The documented entity may have a number of different properties that need to be shown together. As properties are typically compact, they are displayed in a single table, whose left column contain property titles and right column - property values.';
		style.css.className='propTitle';
		text.font.name='SansSerif';
		text.font.size='8';
		text.font.style.bold='true';
		text.decor.underline='false';
		text.color.foreground='#000000';
		par.margin.right='6';
		par.option.nowrap='true';
	}
	CHAR_STYLE={
		style.name='Property Title Font';
		style.id='cs26';
		style.description='Specify only font (text formatting) of property title';
		style.css.className='propTitle-font';
		text.font.name='SansSerif';
		text.font.size='8';
		text.font.style.bold='true';
	}
	PAR_STYLE={
		style.name='Property Value';
		style.id='ps23';
		style.description='The base style for property values. Besides formatting of text, it specifies also a few paragraph settings to ensure necessary spacing between neighbouring rows and cells.

ABOUT PROPERTIES

Properties (in terms of this XML schema documentation) are short pieces of information about particular documented entities (e.g. XSD components, facets etc.) Each property has a title and value. The value may also include additional things, like:
- hyperlinks
- short explanations
- component derivation summary
- a short list of related components, schemas etc.
- a set of related properties (sub-properties)

The documented entity may have a number of different properties that need to be shown together. As properties are typically compact, they are displayed in a single table, whose left column contain property titles and right column - property values.';
		style.css.className='propValue';
		text.font.name='Verdana';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='Property Value Font';
		style.id='cs27';
		style.description='Specify only font (text formatting) of property value';
		style.css.className='propValue-font';
		text.font.name='Verdana';
		text.font.size='8';
	}
	TABLE_STYLE={
		style.name='Representation Box';
		style.id='ts3';
		style.description='Specifies border and background of various representations:
- XML Representation Summary
- Simple Content Representation
- Type Derivation Tree';
		style.css.className='repBox';
		table.cell.padding.both='3';
		table.bkgr.color='#F5F5F5';
		table.border.style='solid';
		table.border.color='#999999';
		table.border.css.render='true';
		table.page.keepTogether='true';
	}
	PAR_STYLE={
		style.name='Summary Heading';
		style.id='ps24';
		style.description='Styles headings of summary tables (when the heading text is placed in a one of the top table cells).';
		style.css.className='sumHead';
		text.font.size='12';
		text.font.style.bold='true';
	}
	CHAR_STYLE={
		style.name='Summary Item';
		style.id='cs28';
		style.description='Used to display component names in the left column of component summary tables. 

The font must be clear-cut (well readable) and compact (the component names are displayed unwrapped, yet some of them may be quite long strings; so, they should occupy as minimal width as possble).';
		style.css.className='sumItem';
		text.font.name='Verdana';
		text.font.size='8';
		text.font.style.bold='true';
	}
	CHAR_STYLE={
		style.name='Summary Item (Large)';
		style.id='cs29';
		style.description='Used to display names of XML schemas in the left column of summary tables. 

The font must be clear-cut (well readable) and compact (the file names are displayed unwrapped, yet some of them may be quite long strings; so, they should occupy as minimal width as possble).';
		style.css.className='sumItem-large';
		text.font.name='Verdana';
		text.font.size='9';
		text.font.style.bold='true';
	}
	PAR_STYLE={
		style.name='Summary Item Heading';
		style.id='ps25';
		style.description='Used to display namespace URIs in the namespace summary tables.

Since namespace URI is a long string, it cannot be displayed in the left column. So, namespace summary consists of a single column, where each namespace URI is a heading of the corresponding cell.';
		style.css.className='sumItemHead';
		text.font.name='SansSerif';
		text.font.size='9';
		text.font.style.bold='true';
		par.margin.bottom='9';
	}
	TABLE_STYLE={
		style.name='Summary Table';
		style.id='ts4';
		style.description='Applied to various summary tables';
		style.css.className='sumTable';
		table.sizing='Relative';
		table.cell.padding.both='2.5';
	}
	TCELL_STYLE={
		style.name='Summary Table Cell';
		style.id='tcs1';
		style.description='Applied to summary table cells

NOTE: This is a stub style with no properties. It may be overridded in a custom style sheet to specify different table cell borders.';
		style.css.className='sumTableCell';
	}
	TROW_STYLE={
		style.name='Summary Table Header';
		style.id='trs1';
		style.description='Specifies the background color of summary table header (the top table row).';
		style.css.className='sumTableHead';
		trow.bkgr.color='#CCCCFF';
	}
	CHAR_STYLE={
		style.name='Timestamp';
		style.id='cs30';
		style.description='Formats the date/time when the documentation has been generated, which is shown beneath the Overview Summary heading.';
		style.css.className='timestamp';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='XML Rep';
		style.id='cs31';
		style.description='The default font for XML Representation Summary.';
		style.css.className='xmlRep';
		text.font.name='Monospaced';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='XML Rep (Small)';
		style.id='cs32';
		style.description='The base font for XML Representation Summary (smaller version).

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRep-small';
		text.font.name='Monospaced';
		text.font.size='7.5';
	}
	CHAR_STYLE={
		style.name='XML Rep Attribute Name';
		style.id='cs33';
		style.description='Formats the attribute names in XML Representation Summary.

NOTE: The attribute names may be simultaneously hyperlinks, which are formatted with the same font/color and highlighted only with underlining. So, in case of HTML, this style will produce the same named CSS rules for both <span> element (to format text) and <a> element (to format hyperlinks, along with \'blended-in hyperlink\' style).';
		style.css.className='xmlRepAttrName';
		text.font.name='Monospaced';
		text.font.size='8';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Rep Attribute Name (Small)';
		style.id='cs34';
		style.description='Formats the type names in the smaller version of XML Representation Summary.

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRepAttrName-small';
		text.font.name='Monospaced';
		text.font.size='7.5';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Rep Attribute Name Hyperlink';
		style.id='cs35';
		style.description='Styles hyperlinks from attribute names in XML Representation Summary';
		style.css.className='xmlRepAttrNameLink';
		text.decor.underline='true';
	}
	CHAR_STYLE={
		style.name='XML Rep Content Model';
		style.id='cs36';
		style.description='Used to format the representation of the element complex content in XML Representation Summary.';
		style.css.className='xmlRepModel';
		text.font.name='Verdana';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='XML Rep Content Model (Small)';
		style.id='cs37';
		style.description='Used to format the representation of the element complex content in the smaller version of XML Representation Summary.

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRepModel-small';
		text.font.name='Verdana';
		text.font.size='8';
	}
	PAR_STYLE={
		style.name='XML Rep Heading';
		style.id='ps26';
		style.description='Heading of XML Representation Summary.';
		style.css.className='xmlRepHead';
		text.font.size='10';
		text.font.style.bold='true';
		text.color.foreground='#990000';
		par.margin.bottom='2';
	}
	PAR_STYLE={
		style.name='XML Rep Heading (Small)';
		style.id='ps27';
		style.description='Heading of XML Representation Summary (smaller version).

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRepHead-small';
		text.font.size='9';
		text.font.style.bold='true';
		text.color.foreground='#990000';
		par.margin.bottom='2';
	}
	CHAR_STYLE={
		style.name='XML Rep Markup';
		style.id='cs38';
		style.description='The font for XML markup characters (such as angle brackets, quotes etc.) used in XML Representation Summary.';
		style.css.className='xmlRepMarkup';
		text.font.name='Monospaced';
		text.font.size='9';
		text.color.foreground='#0000FF';
		text.spacing.nbsp='true';
	}
	CHAR_STYLE={
		style.name='XML Rep Markup (Small)';
		style.id='cs39';
		style.description='The font for XML markup characters (such as angle brackets, quotes etc.) used in the smaller version of XML Representation Summary.

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRepMarkup-small';
		text.font.name='Monospaced';
		text.font.size='7.5';
		text.color.foreground='#0000FF';
		text.spacing.nbsp='true';
	}
	CHAR_STYLE={
		style.name='XML Rep Name';
		style.id='cs40';
		style.description='Used in XML Representation Summary to display the name of the given element (or other component) being represented.';
		style.css.className='xmlRepName';
		text.font.name='Monospaced';
		text.font.size='9';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Rep Name (Small)';
		style.id='cs41';
		style.description='Used in the smaller version of XML Representation Summary to display the name of the given element (or other component) being represented.

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRepName-small';
		text.font.name='Monospaced';
		text.font.size='7.5';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Rep Value';
		style.id='cs42';
		style.description='Used in XML Representation Summary to display the values (i.e. their representations) of attributes and the element\'s simple content.';
		style.css.className='xmlRepValue';
		text.font.name='Monospaced';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='XML Rep Value (Small)';
		style.id='cs43';
		style.description='Used in the smaller version of XML Representation Summary to display the values (i.e. their representations) of attributes and the element\'s simple content.

NOTE: XML Representation Summary may be printed in two versions: normal and smaller. The smaller version is rendered with smaller font sizes. It is used in the details of content model elements and attributes.';
		style.css.className='xmlRepValue-small';
		text.font.name='Monospaced';
		text.font.size='7.5';
	}
	CHAR_STYLE={
		style.name='XML Source';
		style.id='cs44';
		style.description='The default font for the reproduced XML source.';
		style.css.className='src';
		text.font.name='Verdana';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='XML Source Attribute Name';
		style.id='cs45';
		style.description='The font for the names of attributes in the reproduced XML source.';
		style.css.className='srcAttrName';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Source Attribute Name (Reserved)';
		style.id='cs46';
		style.description='The font for reserved attribute names in the reproduced XML source.

Reserved are namespace bindings (e.g. "xmlns:xs") and attributes from the XML namespace (e.g. "xml:lang").';
		style.css.className='srcAttrNameRes';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#FF0000';
	}
	CHAR_STYLE={
		style.name='XML Source Attribute Value';
		style.id='cs47';
		style.description='The font for the values of attributes in the reproduced XML source.

NOTE: The attribute values may be simultaneously hyperlinks, which are formatted with the same font/color and highlighted only with underlining. So, in case of HTML, this style will produce the same named CSS rule for both <span> element (to format just the value text) and <a> element (to format the hyperlink, along with \'blended-in hyperlink\' style).';
		style.css.className='srcAttrVal';
		text.font.name='Verdana';
		text.font.size='7';
		text.font.style.bold='true';
		text.color.foreground='#000000';
	}
	CHAR_STYLE={
		style.name='XML Source Attribute Value (Reserved)';
		style.id='cs48';
		style.description='The font for the values of reserved attributes in the reproduced XML source.

Reserved are namespace bindings (e.g. "xmlns:xs") and attributes from the XML namespace (e.g. "xml:lang").';
		style.css.className='srcAttrValRes';
		text.font.name='Verdana';
		text.font.size='7';
		text.font.style.bold='true';
		text.color.foreground='#FF0000';
	}
	CHAR_STYLE={
		style.name='XML Source Attribute Value Hyperlink';
		style.id='cs49';
		style.description='Styles hyperlinks from values of attributes in the reproduced XML source';
		style.css.className='srcAttrValLink';
		text.decor.underline='true';
	}
	TABLE_STYLE={
		style.name='XML Source Box';
		style.id='ts5';
		style.description='Styles border and background of reproduced XML source (when it is enclodes in a box).';
		style.css.className='srcBox';
		table.cell.padding.both='3';
		table.bkgr.color='#F5F5F5';
		table.border.style='solid';
		table.border.color='#999999';
		table.border.css.render='true';
	}
	CHAR_STYLE={
		style.name='XML Source CDATA';
		style.id='cs50';
		style.description='The font for CDATA section content in the reproduced XML source';
		style.css.className='srcCDATA';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source CDATA Markup';
		style.id='cs51';
		style.description='The font for CDATA section markup ("<![CDATA[" and "]]>") in the reproduced XML source';
		style.css.className='srcCDATAMrk';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source Comment';
		style.id='cs52';
		style.description='The font for XML source comments';
		style.css.className='srcCom';
		text.font.name='Monospaced';
		text.font.size='8';
		text.color.foreground='#4D4D4D';
	}
	CHAR_STYLE={
		style.name='XML Source Comment Markup';
		style.id='cs53';
		style.description='The font for XML comment markup ("<!--" and "-->") in the reproduced XML source';
		style.css.className='srcComMrk';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source DOCTYPE';
		style.id='cs54';
		style.description='The font for <!DOCTYPE> declaration (except internal subset) in the reproduced XML source';
		style.css.className='srcDOCTYPE';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source Element Name';
		style.id='cs55';
		style.description='The font for the names of elements in the reproduced XML source.';
		style.css.className='srcElemName';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Source Element Value';
		style.id='cs56';
		style.description='The font for the values of elements in the reproduced XML source.';
		style.css.className='srcElemVal';
		text.font.name='Verdana';
		text.font.size='7';
		text.font.style.bold='true';
	}
	CHAR_STYLE={
		style.name='XML Source Fragment Hyperlink';
		style.id='cs57';
		style.description='This style is used to indicate a hyperlink assigned to little piece of XML source (with all markup included). That hyperlink doesn\'t reveal itself until mouse cursor hovers over it. Then, the whole text (XML source) is highlighted with the red-colored underlining, which this style defines.

That feature is used only in the XML Namespace Bindings report.';
		style.css.className='srcFrgmLink';
		text.decor.underline='true';
		text.color.foreground='#990000';
	}
	CHAR_STYLE={
		style.name='XML Source Internal Subset';
		style.id='cs58';
		style.description='The font for Internal Subset (embedded in <!DOCTYPE> declaration) in the reproduced XML source.';
		style.css.className='srcIS';
		text.font.name='Monospaced';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source Internal Subset Markup';
		style.id='cs59';
		style.description='The font for specific XML markup surrounding Internal Subset section in the reproduced XML source';
		style.css.className='srcISMrk';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source Markup';
		style.id='cs60';
		style.description='The font for XML markup characters (such as angle brackets, quotes etc.)';
		style.css.className='srcMrk';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='XML Source Processing Instruction';
		style.id='cs61';
		style.description='The font for Processing Instructions in the reproduced XML source.

It will be used also for XML declarions (which have the same syntax as processing instructions), e.g.:
<?xml version="1.0" encoding="UTF-8"?>';
		style.css.className='srcPI';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#0000FF';
	}
</STYLES>
FMT={
	doc.lengthUnits='pt';
	doc.default.font='Arial';
	doc.hlink.style.link='cs17';
}
<FRAMESET>
	LAYOUT='columns'
	<FRAMESET>
		PERCENT_SIZE=20
		LAYOUT='rows'
		<FRAME>
			COND='documentByTemplate (
  "overview-frame"
) != null'
			PERCENT_SIZE=30
			NAME='overviewFrame'
			SOURCE_EXPR='documentByTemplate ("overview-frame")'
		</FRAME>
		<FRAME>
			COND='documentByTemplate (
  "all-components-frame;
   namespace-frame;
   schema-frame"
) != null'
			PERCENT_SIZE=70
			NAME='listFrame'
			SOURCE_EXPR='templateNames = Vector (
  "all-components-frame",
  "namespace-frame",
  "schema-frame"
);

templateNames.moveElement (
  indexOf (
    Array ("allcomps", "namespace", "schema"),
    getStringParam("nav.listFrame")
  ),
  0
);

documentByTemplate (
  templateNames.mergeStrings (\';\')
)'
		</FRAME>
	</FRAMESET>
	<FRAME>
		PERCENT_SIZE=80
		NAME='detailFrame'
		SOURCE_EXPR='templateNames = Vector (
  "overview-summary",
  "all-components-summary",
  "namespace-overview",
  "schema-overview",
  "element", 
  "complexType",
  "simpleType",
  "group",
  "attribute",
  "attributeGroup",
  "xmlns-bindings"
);

templateNames.moveElement (
  indexOf (
    Array ("overview", "allcomps", "namespace", "schema"),
    getStringParam ("nav.detailFrame")
  ),
  0
);

documentByTemplate (
  templateNames.mergeStrings (\';\')
)'
	</FRAME>
</FRAMESET>
DEMO_LIMITS={
	'elements',100;
	'types',100;
	'groups',50;
	'diagrams',20;
}
<ROOT>
	<TEMPLATE_CALL>
		COND='getBooleanParam("gen.doc.overview")'
		TEMPLATE_FILE='lib/overview-summary.tpl'
		OUTPUT_TYPE='document'
		OUTPUT_DIR_EXPR='output.docFilesDir'
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		COND='getBooleanParam("gen.doc.allcomps")'
		TEMPLATE_FILE='lib/component/all-components-summary.tpl'
		OUTPUT_TYPE='document'
		OUTPUT_DIR_EXPR='output.docFilesDir'
		SUPPRESS_EMPTY_FILE
	</TEMPLATE_CALL>
	<ELEMENT_ITER>
		DESCR='ITERATE BY SCHEMAS'
		STEP_EXPR='schemaFolder = makeUniquePath (
  output.docFilesDir + "schemas",
  makeFileName (getXMLDocument().getAttrStringValue("xmlName")),
  ""
) + "/";
setVar ("schemaFolder", schemaFolder);

uri = getServiceAttr("targetNamespace").toString();
setVar("nsURI", uri);

nsFolder = makeFileName (uri);
nsFolder = (nsFolder != "") ? nsFolder :  "no_namespace";
setVar("nsFolder", output.docFilesDir + "namespaces/" + nsFolder + "/");'
		TARGET_ET='xs:schema'
		SCOPE='advanced-location-rules'
		RULES={
			'* -> #DOCUMENT/xs:schema[checkElementsByKey ("documented-schemas", contextElement.id)]';
		}
		SORTING='by-expr'
		SORTING_KEY={expr='getXMLDocument().getAttrStringValue("xmlName")',ascending}
		SORTING_COND='getBooleanParam("gen.doc.sorting.schemas")'
		<BODY>
			<TEMPLATE_CALL>
				DESCR='schema overview'
				COND='getBooleanParam("gen.doc.schema")'
				TEMPLATE_FILE='lib/schema/schema-overview.tpl'
				OUTPUT_TYPE='document'
				OUTPUT_DIR_EXPR='getStringVar("schemaFolder")'
				ASSOCIATED_FILES_DIR_EXPR='getVar("schemaFolder") + "doc-files"'
			</TEMPLATE_CALL>
			<TEMPLATE_CALL>
				DESCR='schema XML source (as a separate file)'
				COND='getBooleanParam("doc.schema.xml")
&&
getBooleanParam("doc.schema.xml.separate")'
				TEMPLATE_FILE='lib/schema/schema-source.tpl'
				OUTPUT_TYPE='document'
				OUTPUT_DIR_EXPR='getStringVar("schemaFolder")'
				ASSOCIATED_FILES_DIR_EXPR='getVar("schemaFolder") + "doc-files"'
			</TEMPLATE_CALL>
			<TEMPLATE_CALL>
				DESCR='schema component list'
				COND='getBooleanParam("nav.listFrame.schema")'
				TEMPLATE_FILE='lib/schema/schema-frame.tpl'
				OUTPUT_TYPE='document'
				OUTPUT_DIR_EXPR='getStringVar("schemaFolder")'
				SUPPRESS_EMPTY_FILE
			</TEMPLATE_CALL>
			<ELEMENT_ITER>
				DESCR='elements'
				COND='getBooleanParam("gen.doc.element")'
				STEP_EXPR='// in how many schemas is this element defined?

schemaCount =
  instanceOf("xs:element") ? 1 // case of global element
  :
  // case of a local element:
  // when it represents a group of local elements unified by type,
  // those elements may be actually defined in different schemas;
  // calculate in how many

  countElementsByKey (
    "globally-documented-local-elements",
    contextElement.id,
    null,
    FlexQuery (getXMLDocument().id)
  );

setVar ("schemaCount", schemaCount);

schemaCount > 1 ? {
  nsURI = getQNameServiceAttr ("qName").namespaceURI;
  nsFolder = makeFileName (nsURI) ?? "no_namespace";
  setVar ("nsFolder", output.docFilesDir + "namespaces/" + nsFolder + "/");
}'
				TARGET_ET='xs:%element'
				SCOPE='simple-location-rules'
				RULES={
					'* -> descendant::xs:%element';
				}
				FILTER='// case of global element
instanceOf("xs:element")
||
// otherwise, check if this is a locally defined element (not a reference)
! hasAttr("ref")
&&
// remain it only when it is globally documented directly (not via a unifier)
findElementByKey (
  "globally-documented-local-elements", contextElement.id
).id == contextElement.id'
				SORTING='by-expr'
				SORTING_KEY={expr='callStockSection("Element Name")',ascending}
				SORTING_COND='getBooleanParam("gen.doc.sorting.comps")'
				<BODY>
					<TEMPLATE_CALL>
						TEMPLATE_FILE='lib/element/element.tpl'
						PASSED_PARAMS={
							'$nsURI','schema = findPredecessorByType ("xs:schema");

// for local elements, their namespace may be not the same
// as the schema\'s target namespace

instanceOf ("xs:element") ? schema.getServiceAttr("targetNamespace") :
  (hasAttr("form") ? getAttrValue("form") :
    schema.getAttrStringValue ("elementFormDefault")) == "qualified" 
      ? schema.getServiceAttr("targetNamespace") : ""';
						}
						OUTPUT_TYPE='document'
						OUTPUT_DIR_EXPR='path = getStringVar ("schemaFolder");

// if this is a local element
instanceOf ("xs:%localElement") ?
{
  // if this is a unified local element
  countElementsByKey ("globally-documented-local-elements", contextElement.id) > 1 ?
  {
    // if this element is defined in several schemas,
    // store its documentation in the folder of the namespace;
    // otherwise, the element documentation is stored by its schema

    getIntVar ("schemaCount") > 1 ? 
      path = getStringVar ("nsFolder");
  } : {
    // otherwise, this is just a local element

    getBooleanParam("gen.doc.element.local.storeByParents") ?
    {
      iterate (
        reverseVector (getPredecessorsUntilType (
          "xs:element | xs:complexType | xs:group", true
        )),
        @(GOMElement) el,
        FlexQuery ({
          path = path + (el.instanceOf ("xs:element") ? "elements" :
                           el.instanceOf ("xs:complexType") ? "complexTypes" :
                             el.instanceOf ("xs:group") ? "groups" : "") + "/" +
                 el.getAttrStringValue("name")
        })
      );

      return path
    }
  }
};

path + "elements"'
						FILE_NAME_EXPR='getAttrStringValue("name")'
						ASSOCIATED_FILES_DIR_EXPR='(getIntVar ("schemaCount") > 1 ?
   getStringVar ("nsFolder") : getStringVar ("schemaFolder")) + "doc-files"'
					</TEMPLATE_CALL>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				DESCR='complexTypes'
				COND='getBooleanParam("gen.doc.complexType")'
				TARGET_ET='xs:complexType'
				SCOPE='simple-location-rules'
				RULES={
					'* -> descendant::xs:complexType';
				}
				SORTING='by-attr'
				SORTING_KEY={lpath='@name',ascending}
				SORTING_COND='getBooleanParam("gen.doc.sorting.comps")'
				<BODY>
					<TEMPLATE_CALL>
						TEMPLATE_FILE='lib/type/complexType.tpl'
						PASSED_PARAMS={
							'$nsURI','getVar("nsURI")';
						}
						OUTPUT_TYPE='document'
						OUTPUT_DIR_EXPR='getVar("schemaFolder") + "complexTypes"'
						FILE_NAME_EXPR='getAttrStringValue("name")'
						ASSOCIATED_FILES_DIR_EXPR='getVar("schemaFolder") + "doc-files"'
					</TEMPLATE_CALL>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				DESCR='simpleTypes'
				COND='getBooleanParam("gen.doc.simpleType")'
				TARGET_ET='xs:simpleType'
				SCOPE='simple-location-rules'
				RULES={
					'* -> descendant::xs:simpleType';
				}
				SORTING='by-attr'
				SORTING_KEY={lpath='@name',ascending}
				SORTING_COND='getBooleanParam("gen.doc.sorting.comps")'
				<BODY>
					<TEMPLATE_CALL>
						TEMPLATE_FILE='lib/type/simpleType.tpl'
						PASSED_PARAMS={
							'$nsURI','getVar("nsURI")';
						}
						OUTPUT_TYPE='document'
						OUTPUT_DIR_EXPR='getVar("schemaFolder") + "simpleTypes"'
						FILE_NAME_EXPR='getAttrStringValue("name")'
						ASSOCIATED_FILES_DIR_EXPR='getVar("schemaFolder") + "doc-files"'
					</TEMPLATE_CALL>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				DESCR='element groups'
				COND='getBooleanParam("gen.doc.group")'
				TARGET_ET='xs:group'
				SCOPE='simple-location-rules'
				RULES={
					'* -> descendant::xs:group';
				}
				SORTING='by-attr'
				SORTING_KEY={lpath='@name',ascending}
				SORTING_COND='getBooleanParam("gen.doc.sorting.comps")'
				<BODY>
					<TEMPLATE_CALL>
						TEMPLATE_FILE='lib/groups/group.tpl'
						PASSED_PARAMS={
							'$nsURI','getVar("nsURI")';
						}
						OUTPUT_TYPE='document'
						OUTPUT_DIR_EXPR='getVar("schemaFolder") + "groups"'
						FILE_NAME_EXPR='getAttrStringValue("name")'
						ASSOCIATED_FILES_DIR_EXPR='getVar("schemaFolder") + "doc-files"'
					</TEMPLATE_CALL>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				DESCR='attribute groups'
				COND='getBooleanParam("gen.doc.attributeGroup")'
				TARGET_ET='xs:attributeGroup'
				SCOPE='simple-location-rules'
				RULES={
					'* -> descendant::xs:attributeGroup';
				}
				SORTING='by-attr'
				SORTING_KEY={lpath='@name',ascending}
				SORTING_COND='getBooleanParam("gen.doc.sorting.comps")'
				<BODY>
					<TEMPLATE_CALL>
						TEMPLATE_FILE='lib/groups/attributeGroup.tpl'
						PASSED_PARAMS={
							'$nsURI','getVar("nsURI")';
						}
						OUTPUT_TYPE='document'
						OUTPUT_DIR_EXPR='getVar("schemaFolder") + "attributeGroups"'
						FILE_NAME_EXPR='getAttrStringValue("name")'
						ASSOCIATED_FILES_DIR_EXPR='getVar("schemaFolder") + "doc-files"'
					</TEMPLATE_CALL>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				DESCR='global attributes'
				COND='getBooleanParam("gen.doc.attribute")'
				TARGET_ET='xs:attribute'
				SCOPE='simple-location-rules'
				RULES={
					'* -> xs:attribute';
				}
				SORTING='by-attr'
				SORTING_KEY={lpath='@name',ascending}
				SORTING_COND='getBooleanParam("gen.doc.sorting.comps")'
				<BODY>
					<TEMPLATE_CALL>
						TEMPLATE_FILE='lib/attribute/globalAttribute.tpl'
						PASSED_PARAMS={
							'$nsURI','getVar("nsURI")';
						}
						OUTPUT_TYPE='document'
						OUTPUT_DIR_EXPR='getVar("schemaFolder") + "attributes"'
						FILE_NAME_EXPR='getAttrStringValue("name")'
						ASSOCIATED_FILES_DIR_EXPR='getVar("schemaFolder") + "doc-files"'
					</TEMPLATE_CALL>
				</BODY>
			</ELEMENT_ITER>
		</BODY>
	</ELEMENT_ITER>
	<ELEMENT_ITER>
		DESCR='ITERATE BY NAMESPACES (see "Processing | Iteration Scope" tab);
namespace URI is saved in \'nsURI\' variable (see "Processing | Init/Step/Finish | Step Expression" tab)'
		STEP_EXPR='uri = contextElement.value.toString();
setVar("nsURI", uri);

nsFolder = makeFileName (uri);
nsFolder = (nsFolder != "") ? nsFolder : "no_namespace";
setVar("nsFolder", output.docFilesDir + "namespaces/" + nsFolder + "/");'
		TARGET_ET='#CUSTOM'
		SCOPE='custom'
		ELEMENT_ENUM_EXPR='toCustomElements (getElementMapKeys("namespaces"))'
		SORTING='by-value'
		SORTING_KEY={lpath='.',ascending}
		SORTING_COND='getBooleanParam("gen.doc.sorting.namespaces")'
		<BODY>
			<TEMPLATE_CALL>
				DESCR='namespace overview'
				COND='getBooleanParam("gen.doc.namespace")'
				TEMPLATE_FILE='lib/namespace/namespace-overview.tpl'
				PASSED_PARAMS={
					'$nsURI','getVar("nsURI")';
				}
				OUTPUT_TYPE='document'
				OUTPUT_DIR_EXPR='getVar("nsFolder").toString()'
				PASSED_ROOT_ELEMENT_EXPR='rootElement'
			</TEMPLATE_CALL>
			<TEMPLATE_CALL>
				DESCR='namespace component list'
				COND='getBooleanParam("nav.listFrame.namespace")'
				TEMPLATE_FILE='lib/namespace/namespace-frame.tpl'
				PASSED_PARAMS={
					'$nsURI','getVar("nsURI")';
				}
				OUTPUT_TYPE='document'
				OUTPUT_DIR_EXPR='getVar("nsFolder").toString()'
				SUPPRESS_EMPTY_FILE
				PASSED_ROOT_ELEMENT_EXPR='rootElement'
			</TEMPLATE_CALL>
		</BODY>
	</ELEMENT_ITER>
	<TEMPLATE_CALL>
		COND='getBooleanParam("nav.listFrame.allcomps")'
		TEMPLATE_FILE='lib/component/all-components-frame.tpl'
		OUTPUT_TYPE='document'
		OUTPUT_DIR_EXPR='output.docFilesDir'
		SUPPRESS_EMPTY_FILE
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		COND='getBooleanParam("nav.overviewFrame")'
		TEMPLATE_FILE='lib/overview-frame.tpl'
		OUTPUT_TYPE='document'
		OUTPUT_DIR_EXPR='output.docFilesDir'
		SUPPRESS_EMPTY_FILE
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		COND='getBooleanParam("gen.doc.xmlnsBindings")'
		TEMPLATE_FILE='lib/xml/xmlns-bindings.tpl'
		OUTPUT_TYPE='document'
		OUTPUT_DIR_EXPR='output.docFilesDir'
		SUPPRESS_EMPTY_FILE
	</TEMPLATE_CALL>
</ROOT>
<STOCK_SECTIONS>
	<TEMPLATE_CALL>
		SS_NAME='Component Name'
		DESCR='prints the qualified name of any global schema component and local element (passed as the stock-section context element)'
		TEMPLATE_FILE='lib/component/componentName.tpl'
		PASSED_PARAMS={
			'$targetFrame','"detailFrame"';
		}
		FMT={
			sec.outputStyle='text-par';
		}
	</TEMPLATE_CALL>
	<AREA_SEC>
		SS_NAME='Element Name'
		MATCHING_ET='xs:%element'
		<AREA>
			<CTRL_GROUP>
				<CTRLS>
					<DATA_CTRL>
						ATTR='name'
						<DOC_HLINK>
							HKEYS={
								'contextElement.id';
								'"detail"';
							}
						</DOC_HLINK>
					</DATA_CTRL>
					<TEMPLATE_CALL_CTRL>
						MATCHING_ET='xs:%localElement'
						TEMPLATE_FILE='lib/element/localElementExt.tpl'
					</TEMPLATE_CALL_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
	<FOLDER>
		SS_NAME='Init'
		MATCHING_ET='#DOCUMENTS'
		NO_DIRECT_OUTPUT
		<BODY>
			<TEMPLATE_CALL>
				TEMPLATE_FILE='lib/init.tpl'
				OUTPUT_TYPE='document'
			</TEMPLATE_CALL>
			<TEMPLATE_CALL>
				DESCR='prepare diagramming engine'
				COND='dsmType.imageProvider != null
&&
getBooleanParam("DiagramKit")'
				TEMPLATE_FILE='lib/diagramming/DiagramKit.tpl'
				OUTPUT_TYPE='document'
			</TEMPLATE_CALL>
			<FOLDER COLLAPSED='true'>
				DESCR='check demo limits'
				COND='output.demoMode'
				<BODY>
					<ELEMENT_ITER>
						DESCR='by namespaces'
						COND='hasParamValue("nav.listFrame", "namespace")'
						BREAK_PARENT_BLOCK='when-executed'
						STEP_EXPR='setVar("nsURI", contextElement.value.toString())'
						TARGET_ET='#CUSTOM'
						SCOPE='custom'
						ELEMENT_ENUM_EXPR='toCustomElements (getElementMapKeys("namespaces"))'
						SORTING='by-value'
						SORTING_KEY={lpath='.',ascending}
						SORTING_COND='getBooleanParam("gen.doc.sorting.namespaces")'
						<BODY>
							<FOLDER>
								COND='getBooleanParam("gen.doc.element")'
								<BODY>
									<ELEMENT_ITER>
										DESCR='top-level elements'
										COND='getBooleanParam("gen.doc.element.topLevel")'
										TARGET_ET='xs:element'
										SCOPE='advanced-location-rules'
										RULES={
											'* -> {findElementsByKey ("namespaces", getVar("nsURI"))}::xs:schema/xs:element[getServiceAttr("isTopLevel").toBoolean()]';
										}
										SORTING='by-expr'
										SORTING_KEY={expr='callStockSection("Component Name")',ascending}
										SORTING_COND='getBooleanParam("gen.doc.element.topLevel.sorting")'
										DEMO_LIMIT_KEY='elements'
										DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
									</ELEMENT_ITER>
									<ELEMENT_ITER>
										DESCR='other elements'
										COND='getBooleanParam("nav.listFrame.namespace.elements")'
										TARGET_ET='xs:%element'
										SCOPE='advanced-location-rules'
										RULES={
											'* -> {findElementsByKey ("namespaces", getVar("nsURI"))}::xs:schema/descendant::xs:%element[instanceOf("xs:element") || ! hasAttr("ref") &&
{
  form = hasAttr("form") ? getAttrValue("form") :
           findAncestor ("xs:schema").getAttrStringValue ("elementFormDefault");

  (form == "qualified" || getStringVar("nsURI") == "")
}]';
											'*[getVar("nsURI") == ""] -> {findElementsByKey ("namespaces", "")}::xs:%localElement';
										}
										FILTER='instanceOf("xs:element") ?
  ! getBooleanParam("gen.doc.element.topLevel") ||
  ! getServiceAttr ("isTopLevel").toBoolean()
:
// case of local element
({
  // remain only those local elements that are either not documented globally at all
  // or documented globaly themselves (not via a unifier)

  el = findElementByKey ("globally-documented-local-elements", contextElement.id);
  el == null || el.id == contextElement.id
}
&&
{
  // which local elements to list?
  local = getStringParam("nav.listFrame.namespace.elements.local");
  
  local == "complexType" ?
    ((typeQName = getAttrQNameValue("type")) != null) ?
    {
      mainXSD = findElementByKey ("main-xsds", getXMLDocument().id);

      checkElementsByKey ("types", typeQName,
        BooleanQuery (
          instanceOf("xs:complexType")
          &&
          checkElementByKey ("main-xsds", getXMLDocument().id, mainXSD)
        )
      )
    }
    : hasChild("xs:complexType")
  :
  local == "all"
})'
										SORTING='by-expr'
										SORTING_KEY={expr='callStockSection("Component Name")',ascending}
										SORTING_COND='getBooleanParam("nav.listFrame.namespace.sorting")'
										DEMO_LIMIT_KEY='elements'
										DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
									</ELEMENT_ITER>
								</BODY>
							</FOLDER>
							<ELEMENT_ITER>
								COND='getBooleanParam("gen.doc.complexType")'
								TARGET_ET='xs:complexType'
								SCOPE='advanced-location-rules'
								RULES={
									'* -> {findElementsByKey ("namespaces", getVar("nsURI"))}::xs:schema';
									'xs:schema -> xs:complexType',recursive;
									'xs:schema -> xs:redefine/xs:complexType',recursive;
								}
								SORTING='by-compound-key'
								SORTING_KEY={
									{expr='getAttrStringValue("name")',ascending};
									{expr='getServiceAttr("version").toInt()',ascending};
								}
								SORTING_COND='getBooleanParam("nav.listFrame.namespace.sorting")'
								DEMO_LIMIT_KEY='types'
								DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
							</ELEMENT_ITER>
							<ELEMENT_ITER>
								COND='getBooleanParam("gen.doc.simpleType")'
								TARGET_ET='xs:simpleType'
								SCOPE='advanced-location-rules'
								RULES={
									'* -> {findElementsByKey ("namespaces", getVar("nsURI"))}::xs:schema';
									'xs:schema -> xs:simpleType',recursive;
									'xs:schema -> xs:redefine/xs:simpleType',recursive;
								}
								SORTING='by-compound-key'
								SORTING_KEY={
									{expr='getAttrStringValue("name")',ascending};
									{expr='getServiceAttr("version").toInt()',ascending};
								}
								SORTING_COND='getBooleanParam("nav.listFrame.namespace.sorting")'
								DEMO_LIMIT_KEY='types'
							</ELEMENT_ITER>
							<ELEMENT_ITER>
								COND='getBooleanParam("gen.doc.group")'
								TARGET_ET='xs:group'
								SCOPE='advanced-location-rules'
								RULES={
									'* -> {findElementsByKey ("namespaces", getVar("nsURI"))}::xs:schema';
									'xs:schema -> xs:group',recursive;
									'xs:schema -> xs:redefine/xs:group',recursive;
								}
								SORTING='by-compound-key'
								SORTING_KEY={
									{expr='getAttrStringValue("name")',ascending};
									{expr='getServiceAttr("version").toInt()',ascending};
								}
								SORTING_COND='getBooleanParam("nav.listFrame.namespace.sorting")'
								DEMO_LIMIT_KEY='groups'
								DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
							</ELEMENT_ITER>
							<ELEMENT_ITER>
								COND='getBooleanParam("gen.doc.attributeGroup")'
								TARGET_ET='xs:attributeGroup'
								SCOPE='advanced-location-rules'
								RULES={
									'* -> {findElementsByKey ("namespaces", getVar("nsURI"))}::xs:schema';
									'xs:schema -> xs:attributeGroup',recursive;
									'xs:schema -> xs:redefine/xs:attributeGroup',recursive;
								}
								SORTING='by-compound-key'
								SORTING_KEY={
									{expr='getAttrStringValue("name")',ascending};
									{expr='getServiceAttr("version").toInt()',ascending};
								}
								SORTING_COND='getBooleanParam("nav.listFrame.namespace.sorting")'
								DEMO_LIMIT_KEY='groups'
								DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
							</ELEMENT_ITER>
						</BODY>
					</ELEMENT_ITER>
					<ELEMENT_ITER>
						DESCR='by schemas'
						COND='hasParamValue("nav.listFrame", "schema")'
						BREAK_PARENT_BLOCK='when-executed'
						TARGET_ET='xs:schema'
						SCOPE='advanced-location-rules'
						RULES={
							'* -> #DOCUMENT/xs:schema[checkElementsByKey ("documented-schemas", contextElement.id)]';
						}
						SORTING='by-expr'
						SORTING_KEY={expr='getXMLDocument().getAttrStringValue("xmlName")',ascending}
						SORTING_COND='getBooleanParam("gen.doc.sorting.schemas")'
						<BODY>
							<FOLDER>
								COND='getBooleanParam("gen.doc.element")'
								<BODY>
									<ELEMENT_ITER>
										DESCR='top-level elements'
										COND='getBooleanParam("gen.doc.element.topLevel")'
										TARGET_ET='xs:element'
										SCOPE='advanced-location-rules'
										RULES={
											'* -> xs:element[getServiceAttr("isTopLevel").toBoolean()]';
										}
										SORTING='by-expr'
										SORTING_KEY={expr='callStockSection("Component Name")',ascending}
										SORTING_COND='getBooleanParam("gen.doc.element.topLevel.sorting")'
										DEMO_LIMIT_KEY='elements'
										DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
									</ELEMENT_ITER>
									<ELEMENT_ITER>
										DESCR='other elements'
										TARGET_ET='xs:%element'
										SCOPE='advanced-location-rules'
										RULES={
											'* -> descendant::xs:%element/{// if this is a global element, return it
instanceOf("xs:element") ? return Enum (contextElement);

// if this is a reference to global element, return empty enumeration
getAttrValue("ref") != null ? return null;

// otherwise, it is a local element

// if this local element is documented globally replace it with its unifier
// (when several local elements are unified by type, during the generation 
// all of them are represented by a single local element component -- the unifier -- 
// which may be actually even from a different schema); 
// otherwise, return the same element

el = findElementByKey ("globally-documented-local-elements", contextElement.id);
Enum (el != null ? el : contextElement)}::xs:%element';
										}
										FILTER='instanceOf("xs:element") ?
  ! getBooleanParam("gen.doc.element.topLevel") ||
  ! getServiceAttr ("isTopLevel").toBoolean()
:
// case of local element
{
  // which local elements to list?
  local = getStringParam("nav.listFrame.schema.elements.local");
  
  local == "complexType" ?
    ((typeQName = getAttrQNameValue("type")) != null) ?
    {
      mainXSD = findElementByKey ("main-xsds", getXMLDocument().id);

      checkElementsByKey (
        "types", typeQName,
        BooleanQuery (
          instanceOf("xs:complexType")
          &&
          checkElementByKey ("main-xsds", getXMLDocument().id, mainXSD)
        )
      )
    }
    : hasChild("xs:complexType")
  :
  local == "all"
}'
										SORTING='by-expr'
										SORTING_KEY={expr='callStockSection("Component Name")',ascending}
										SORTING_COND='getBooleanParam("nav.listFrame.schema.sorting")'
										DEMO_LIMIT_KEY='elements'
										DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
									</ELEMENT_ITER>
								</BODY>
							</FOLDER>
							<ELEMENT_ITER>
								COND='getBooleanParam("gen.doc.complexType")'
								TARGET_ET='xs:complexType'
								SCOPE='advanced-location-rules'
								RULES={
									'* -> xs:complexType';
									'* -> xs:redefine/xs:complexType';
								}
								SORTING='by-compound-key'
								SORTING_KEY={
									{expr='toXMLName (
  findAncestor ("xs:schema").getServiceAttr("targetNamespace").toString(),
  getAttrStringValue("name")
)',ascending};
									{expr='getServiceAttr("version").toInt()',ascending};
								}
								SORTING_COND='getBooleanParam("nav.listFrame.allcomps.sorting")'
								DEMO_LIMIT_KEY='types'
								DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
							</ELEMENT_ITER>
							<ELEMENT_ITER>
								COND='getBooleanParam("gen.doc.simpleType")'
								TARGET_ET='xs:simpleType'
								SCOPE='advanced-location-rules'
								RULES={
									'* -> xs:simpleType';
									'* -> xs:redefine/xs:simpleType';
								}
								SORTING='by-compound-key'
								SORTING_KEY={
									{expr='toXMLName (
  findAncestor ("xs:schema").getServiceAttr("targetNamespace").toString(),
  getAttrStringValue("name")
)',ascending};
									{expr='getServiceAttr("version").toInt()',ascending};
								}
								SORTING_COND='getBooleanParam("nav.listFrame.allcomps.sorting")'
								DEMO_LIMIT_KEY='types'
							</ELEMENT_ITER>
							<ELEMENT_ITER>
								COND='getBooleanParam("gen.doc.group")'
								TARGET_ET='xs:group'
								SCOPE='advanced-location-rules'
								RULES={
									'* -> xs:group';
									'* -> xs:redefine/xs:group';
								}
								SORTING='by-compound-key'
								SORTING_KEY={
									{expr='toXMLName (
  findAncestor ("xs:schema").getServiceAttr("targetNamespace").toString(),
  getAttrStringValue("name")
)',ascending};
									{expr='getServiceAttr("version").toInt()',ascending};
								}
								SORTING_COND='getBooleanParam("nav.listFrame.allcomps.sorting")'
								DEMO_LIMIT_KEY='groups'
								DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
							</ELEMENT_ITER>
							<ELEMENT_ITER>
								COND='getBooleanParam("gen.doc.attributeGroup")'
								TARGET_ET='xs:attributeGroup'
								SCOPE='advanced-location-rules'
								RULES={
									'* -> xs:attributeGroup';
									'* -> xs:redefine/xs:attributeGroup';
								}
								SORTING='by-compound-key'
								SORTING_KEY={
									{expr='toXMLName (
  findAncestor ("xs:schema").getServiceAttr("targetNamespace").toString(),
  getAttrStringValue("name")
)',ascending};
									{expr='getServiceAttr("version").toInt()',ascending};
								}
								SORTING_COND='getBooleanParam("nav.listFrame.allcomps.sorting")'
								DEMO_LIMIT_KEY='groups'
								DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
							</ELEMENT_ITER>
						</BODY>
					</ELEMENT_ITER>
					<FOLDER>
						DESCR='all components'
						<BODY>
							<FOLDER>
								COND='getBooleanParam("gen.doc.element")'
								<BODY>
									<ELEMENT_ITER>
										DESCR='top-level elements'
										COND='getBooleanParam("gen.doc.element.topLevel")'
										TARGET_ET='xs:element'
										SCOPE='advanced-location-rules'
										RULES={
											'* -> #DOCUMENT/xs:schema[checkElementsByKey ("documented-schemas", contextElement.id)]/xs:element[getServiceAttr("isTopLevel").toBoolean()]';
										}
										SORTING='by-expr'
										SORTING_KEY={expr='callStockSection("Component Name")',ascending}
										SORTING_COND='getBooleanParam("gen.doc.element.topLevel.sorting")'
										DEMO_LIMIT_KEY='elements'
										DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
									</ELEMENT_ITER>
									<ELEMENT_ITER>
										DESCR='other elements'
										TARGET_ET='xs:%element'
										SCOPE='advanced-location-rules'
										RULES={
											'* -> #DOCUMENT/xs:schema[checkElementsByKey ("documented-schemas", contextElement.id)]/descendant::xs:%element';
										}
										FILTER='instanceOf("xs:element") ?
  ! getBooleanParam("gen.doc.element.topLevel") ||
  ! getServiceAttr ("isTopLevel").toBoolean()
:
! hasAttr("ref")
&&
{
  // remain only those local elements that are either not documented globally at all
  // or documented globaly themselves (not via a unifier)

  el = findElementByKey ("globally-documented-local-elements", contextElement.id);
  el == null || el.id == contextElement.id
}
&&
{
  // which local elements to list?
  local = getStringParam("nav.listFrame.allcomps.elements.local");
  
  local == "complexType" ?
    ((typeQName = getAttrQNameValue("type")) != null) ?
    {
      mainXSD = findElementByKey ("main-xsds", getXMLDocument().id);

      checkElementsByKey (
        "types", typeQName,
        BooleanQuery (
          instanceOf("xs:complexType")
          &&
          checkElementByKey ("main-xsds", getXMLDocument().id, mainXSD)
        )
      )
    }
    : hasChild("xs:complexType")
  :
  local == "all"
}'
										SORTING='by-expr'
										SORTING_KEY={expr='callStockSection("Component Name")',ascending}
										SORTING_COND='getBooleanParam("nav.listFrame.allcomps.sorting")'
										DEMO_LIMIT_KEY='elements'
										DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
									</ELEMENT_ITER>
								</BODY>
							</FOLDER>
							<ELEMENT_ITER>
								COND='getBooleanParam("gen.doc.complexType")'
								TARGET_ET='xs:complexType'
								SCOPE='advanced-location-rules'
								RULES={
									'* -> #DOCUMENT/xs:schema[checkElementsByKey ("documented-schemas", contextElement.id)]';
									'xs:schema -> xs:complexType',recursive;
									'xs:schema -> xs:redefine/xs:complexType',recursive;
								}
								SORTING='by-compound-key'
								SORTING_KEY={
									{expr='toXMLName (
  findAncestor ("xs:schema").getServiceAttr("targetNamespace").toString(),
  getAttrStringValue("name")
)',ascending};
									{expr='getServiceAttr("version").toInt()',ascending};
								}
								SORTING_COND='getBooleanParam("nav.listFrame.allcomps.sorting")'
								DEMO_LIMIT_KEY='types'
								DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
							</ELEMENT_ITER>
							<ELEMENT_ITER>
								COND='getBooleanParam("gen.doc.simpleType")'
								TARGET_ET='xs:simpleType'
								SCOPE='advanced-location-rules'
								RULES={
									'* -> #DOCUMENT/xs:schema[checkElementsByKey ("documented-schemas", contextElement.id)]';
									'xs:schema -> xs:simpleType',recursive;
									'xs:schema -> xs:redefine/xs:simpleType',recursive;
								}
								SORTING='by-compound-key'
								SORTING_KEY={
									{expr='toXMLName (
  findAncestor ("xs:schema").getServiceAttr("targetNamespace").toString(),
  getAttrStringValue("name")
)',ascending};
									{expr='getServiceAttr("version").toInt()',ascending};
								}
								SORTING_COND='getBooleanParam("nav.listFrame.allcomps.sorting")'
								DEMO_LIMIT_KEY='types'
							</ELEMENT_ITER>
							<ELEMENT_ITER>
								COND='getBooleanParam("gen.doc.group")'
								TARGET_ET='xs:group'
								SCOPE='advanced-location-rules'
								RULES={
									'* -> #DOCUMENT/xs:schema[checkElementsByKey ("documented-schemas", contextElement.id)]';
									'xs:schema -> xs:group',recursive;
									'xs:schema -> xs:redefine/xs:group',recursive;
								}
								SORTING='by-compound-key'
								SORTING_KEY={
									{expr='toXMLName (
  findAncestor ("xs:schema").getServiceAttr("targetNamespace").toString(),
  getAttrStringValue("name")
)',ascending};
									{expr='getServiceAttr("version").toInt()',ascending};
								}
								SORTING_COND='getBooleanParam("nav.listFrame.allcomps.sorting")'
								DEMO_LIMIT_KEY='groups'
								DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
							</ELEMENT_ITER>
							<ELEMENT_ITER>
								COND='getBooleanParam("gen.doc.attributeGroup")'
								TARGET_ET='xs:attributeGroup'
								SCOPE='advanced-location-rules'
								RULES={
									'* -> #DOCUMENT/xs:schema[checkElementsByKey ("documented-schemas", contextElement.id)]';
									'xs:schema -> xs:attributeGroup',recursive;
									'xs:schema -> xs:redefine/xs:attributeGroup',recursive;
								}
								SORTING='by-compound-key'
								SORTING_KEY={
									{expr='toXMLName (
  findAncestor ("xs:schema").getServiceAttr("targetNamespace").toString(),
  getAttrStringValue("name")
)',ascending};
									{expr='getServiceAttr("version").toInt()',ascending};
								}
								SORTING_COND='getBooleanParam("nav.listFrame.allcomps.sorting")'
								DEMO_LIMIT_KEY='groups'
								DEMO_LIMIT_EXPR='getBooleanParam("doc.comp.diagram") ?
  checkDemoLimit("diagrams")'
							</ELEMENT_ITER>
						</BODY>
					</FOLDER>
				</BODY>
			</FOLDER>
		</BODY>
	</FOLDER>
</STOCK_SECTIONS>
CHECKSUM='110cgFDL1Quy21OnlALsLmjHydpfPwvFJ2QbXuRcIxE'
</FLEXDOCXYZ_TEMPLATE>